{$A+,B-,D-,E+,F-,G+,I-,L-,N+,P-,Q-,R-,S-,T-,V+,X+,Y-}
{$M 16384,0}
Program Disassamble_CP1600;

Uses Crt,Dos,HexWrite,WinAPI;

Const
  CartSize        = $B000;
  CartStart: Word = $5000;
  BMnem : Array[0..15] Of String[4] =
   ('JMP ','BC  ','BOV ','BPL ','BEQ ','BLT ','BLE ','BUSC',
    'NOP ','BNC ','BNOV','BMI ','BNEQ','BGE ','BGT ','BESC');

Type
  BPtr = ^Byte;
  WPtr = ^Word;

Var
  InFile      : File;
  OutFile     : Text;
  PBuf        : Pointer;{Array[0..CartSize - 1] Of Word;}
  InFileName  : String;
  OutFileName : String;
  Loaded      : LongInt;
  St,St1      : String;
  W1,W2,W3    : Word;
  I,J         : LongInt;
  Disp        : LongInt;
  SDBD        : Byte;
  PJump       : Pointer;
  BufSel      : Word;
  Loading     : LongInt;
  P           : Pointer;
  Swap        : Boolean;

Function UpperCase(St: String): String;
Var I: Integer;
Begin
  For I := 1 To Length(St) Do St[I] := UpCase(St[I]);
  UpperCase := St;
End; { UpperCase }


Function GetBuf(Addr: Word): Word;
Var
  P : WPtr;
  W : Word;

Begin
  P := Ptr(Seg(PBuf^) + (Addr Div 32768) * SelectorInc,Ofs(PBuf^) + (Addr And 32767) * 2);
  W := P^;
(*
  Asm
    ROR   WORD PTR W,8
  End; { Asm }
*)
  GetBuf := W;
End; { GetBuf }

Procedure SetJump(JAddr: Word);
Var
  P    : BPtr;
  Addr : Word;

Begin
  Addr := JAddr Shr 3;
  P    := Ptr(Seg(PJump^),Ofs(PJump^) + Addr);
  P^   := P^ Or (1 Shl (JAddr And 7));
End; { SetJump }

Function GetJump(JAddr: Word): Boolean;
Var
  P    : BPtr;
  Addr : Word;

Begin
  Addr    := JAddr Shr 3;
  P    := Ptr(Seg(PJump^),Ofs(PJump^) + Addr);
  GetJump := ((P^ And (1 Shl (JAddr And 7))) <> 0);
End; { GetJump }

Function IntToStr(L: LongInt): String;
Var St: String;
Begin
  Str(L,St);
  IntToStr := St;
End; { IntToStr }

Procedure Disassemble(Print: Boolean);
Var OldI : LongInt;
Begin
  I    := 0;
  SDBD := 0;
  While I < Loaded Do
  Begin
    If (I And $FFF) = 0 Then WriteLn(HexWord(I + CartStart));
    OldI := I;
    If SDBD > 0 Then Dec(SDBD);
{
    If GetJump(I + CartStart)
     Then St := HexWord(I + CartStart) + '  ' + HexWord(GetBuf(I)) + '  '
     Else St := '      ' + HexWord(GetBuf(I)) + '  ';
}
    St := '';
    Case GetBuf(I) Of
       0: St := St + 'HLT';
       1: Begin
            St   := St + 'SDBD';
            SDBD := 2;
          End;
       2: St := St + 'EIS';
       3: St := St + 'DIS';
       4: Begin
            W1 := GetBuf(I);
            W2 := GetBuf(I + 1);
            W3 := GetBuf(I + 2);
            Case (W2 And 3) Of
              0: If (W2 And $300) = $300 Then St := St + 'J      ' Else St := St + 'JSR    R';
              1: If (W2 And $300) = $300 Then St := St + 'JE     ' Else St := St + 'JSRE   R';
              2: If (W2 And $300) = $300 Then St := St + 'JD     ' Else St := St + 'JSRD   R';
            End; { Case }
            If (W2 And $300) <> $300 Then St := St + IntToStr(((W2 And $300) Shr 8) + 4) + ',';
            St := St + HexWord((W3 And $3FF) + ((W2 And $FC) Shl 8));
            SetJump((W3 And $3FF) + ((W2 And $FC) Shl 8));
            Inc(I,2);
          End;
       5: St := St + 'TCI';
       6: St := St + 'CLRC';
       7: St := St + 'SETC';
   8..15: St := St + 'INCR   R' + IntToStr(GetBuf(I) And 7);
  16..23: St := St + 'DECR   R' + IntToStr(GetBuf(I) And 7);
  24..31: St := St + 'COMR   R' + IntToStr(GetBuf(I) And 7);
  32..39: St := St + 'NEGR   R' + IntToStr(GetBuf(I) And 7);
  40..47: St := St + 'ADCR   R' + IntToStr(GetBuf(I) And 7);
  48..51: St := St + 'GSWD   R' + IntToStr(GetBuf(I) And 3);
  52..53: St := St + 'NOP';
  54..55: St := St + 'SIN';
  56..63: St := St + 'RSWD   R' + IntToStr(GetBuf(I) And 7);
  64..71: Begin
            St := St + 'SWAP   R' + IntToStr(GetBuf(I) And 3);
            If (GetBuf(I) And 4) <> 0 Then St := St + ',2';
          End;
  72..79: Begin
            St := St + 'SLL    R' + IntToStr(GetBuf(I) And 3);
            If (GetBuf(I) And 4) <> 0 Then St := St + ',2';
          End;
  80..87: Begin
            St := St + 'RLC    R' + IntToStr(GetBuf(I) And 3);
            If (GetBuf(I) And 4) <> 0 Then St := St + ',2';
          End;
  88..95: Begin
            St := St + 'SLLC   R' + IntToStr(GetBuf(I) And 3);
            If (GetBuf(I) And 4) <> 0 Then St := St + ',2';
          End;
 96..103: Begin
            St := St + 'SLR    R' + IntToStr(GetBuf(I) And 3);
            If (GetBuf(I) And 4) <> 0 Then St := St + ',2';
          End;
104..111: Begin
            St := St + 'SAR    R' + IntToStr(GetBuf(I) And 3);
            If (GetBuf(I) And 4) <> 0 Then St := St + ',2';
          End;
112..119: Begin
            St := St + 'RRC    R' + IntToStr(GetBuf(I) And 3);
            If (GetBuf(I) And 4) <> 0 Then St := St + ',2';
          End;
120..127: Begin
            St := St + 'SARC   R' + IntToStr(GetBuf(I) And 3);
            If (GetBuf(I) And 4) <> 0 Then St := St + ',2';
          End;
128..191: Begin
            If (GetBuf(I) And 7) = 7 Then
             St := St + 'JR     R' + IntToStr((GetBuf(I) Shr 3) And 7)
            Else
            Begin
              If (GetBuf(I) And 7) = ((GetBuf(I) Shr 3) And 7)
               Then St := St + 'TSTR   R' + IntToStr((GetBuf(I) Shr 3) And 7)
               Else St := St + 'MOVR   R' + IntToStr((GetBuf(I) Shr 3) And 7) +
                                     ',R' + IntToStr(GetBuf(I) And 7);
            End;
          End;
192..255: St := St + 'ADDR   R' + IntToStr((GetBuf(I) Shr 3) And 7) +
                           ',R' + IntToStr(GetBuf(I) And 7);
256..319: St := St + 'SUBR   R' + IntToStr((GetBuf(I) Shr 3) And 7) +
                           ',R' + IntToStr(GetBuf(I) And 7);
320..383: St := St + 'CMPR   R' + IntToStr((GetBuf(I) Shr 3) And 7) +
                           ',R' + IntToStr(GetBuf(I) And 7);
384..447: St := St + 'ANDR   R' + IntToStr((GetBuf(I) Shr 3) And 7) +
                           ',R' + IntToStr(GetBuf(I) And 7);
448..511: St := St + 'XORR   R' + IntToStr((GetBuf(I) Shr 3) And 7) +
                           ',R' + IntToStr(GetBuf(I) And 7);
512..575: Begin
            Disp := GetBuf(I + 1);
            If (GetBuf(I) And $20) <> 0 Then Disp := -(Disp + 1);
            Inc(Disp,CartStart + I + 2);
            If (GetBuf(I) And $20) <> 0 Then St1 := '-' Else St1 := '+';
            If (GetBuf(I) And $10) <> 0
             Then St := St + 'BEXT   ' + HexWord(Disp) +{St1 + HexWord(GetBuf(I + 1)) +}
                                   ',' + IntToStr(GetBuf(I) And $F)
             Else St := St + BMnem[GetBuf(I) And $F] + '   ' + HexWord(Disp);{St1 + HexWord(GetBuf(I + 1));}
            SetJump(Disp);
            Inc(I);
          End;
576..583: Begin
            If SDBD = 1 Then
            Begin
              St := St + 'MVO    R' + IntToStr(GetBuf(I) And 7) +
                                ',' + HexWord((GetBuf(I + 1) And $FF) + (GetBuf(I + 2) Shl 8));
              Inc(I,2);
            End
            Else
            Begin
              St := St + 'MVO    R' + IntToStr(GetBuf(I) And 7) +
                                ',' + HexWord(GetBuf(I + 1));
              Inc(I);
            End;
          End;
584..639: Begin
            Case (GetBuf(I) Shr 3) And 7 Of
              0..5: St := St + 'MVO@   R' + IntToStr(GetBuf(I) And 7) +
                                     ',R' + IntToStr((GetBuf(I) Shr 3) And 7);
                 6: St := St + 'PSHR   R' + IntToStr(GetBuf(I) And 7);
                 7: Begin
                      If SDBD = 1 Then
                      Begin
                        St := St + 'MVOI   R' + IntToStr(GetBuf(I) And 7) +
                                          ',' + HexWord((GetBuf(I + 1) And $FF) + (GetBuf(I + 2) Shl 8));
                        Inc(I,2);
                      End
                      Else
                      Begin
                        St := St + 'MVOI   R' + IntToStr(GetBuf(I) And 7) +
                                          ',' + HexWord(GetBuf(I + 1));
                        Inc(I);
                      End;
                    End;
            End; { Case }
          End;
640..647: Begin
          If SDBD = 1 Then
          Begin
            St := St + 'MVI    ' + HexWord((GetBuf(I + 1) And $FF) + (GetBuf(I + 2) Shl 8)) +
                            ',R' + IntToStr(GetBuf(I) And 7);
            Inc(I,2);
          End
          Else
          Begin
            St := St + 'MVI    ' + HexWord(GetBuf(I + 1)) +
                            ',R' + IntToStr(GetBuf(I) And 7);
            Inc(I);
          End;
        End;
648..703: Begin
          Case (GetBuf(I) Shr 3) And 7 Of
            0..5: St := St + 'MVI@   R' + IntToStr((GetBuf(I) Shr 3) And 7) +
                                   ',R' + IntToStr(GetBuf(I) And 7);
               6: St := St + 'PULR   R' + IntToStr(GetBuf(I) And 7);
               7: Begin
                    If SDBD = 1 Then
                    Begin
                      St := St + 'MVII   ' + HexWord((GetBuf(I + 1) And $FF) + (GetBuf(I + 2) Shl 8)) +
                                      ',R' + IntToStr(GetBuf(I) And 7);
                      Inc(I,2);
                    End
                    Else
                    Begin
                      St := St + 'MVII   ' + HexWord(GetBuf(I + 1)) +
                                      ',R' + IntToStr(GetBuf(I) And 7);
                      Inc(I);
                    End;
                  End;
          End; { Case }
        End;
704..711: Begin
          If SDBD = 1 Then
          Begin
            St := St + 'ADD    ' + HexWord((GetBuf(I + 1) And $FF) + (GetBuf(I + 2) Shl 8)) +
                            ',R' + IntToStr(GetBuf(I) And 7);
            Inc(I,2);
          End
          Else
          Begin
            St := St + 'ADD    ' + HexWord(GetBuf(I + 1)) +
                            ',R' + IntToStr(GetBuf(I) And 7);
            Inc(I);
          End;
        End;
712..767: If ((GetBuf(I) Shr 3) And 7) <> 7 Then
         St := St + 'ADD@   R' + IntToStr((GetBuf(I) Shr 3) And 7) +
                         ',R' + IntToStr(GetBuf(I) And 7)
        Else
        Begin
          If SDBD = 1 Then
          Begin
            St := St + 'ADDI   ' + HexWord((GetBuf(I + 1) And $FF) + (GetBuf(I + 2) Shl 8)) +
                            ',R' + IntToStr(GetBuf(I) And 7);
            Inc(I,2);
          End
          Else
          Begin
            St := St + 'ADDI   ' + HexWord(GetBuf(I + 1)) +
                            ',R' + IntToStr(GetBuf(I) And 7);
            Inc(I);
          End;
        End;
768..775: Begin
          If SDBD = 1 Then
          Begin
            St := St + 'SUB    ' + HexWord((GetBuf(I + 1) And $FF) + (GetBuf(I + 2) Shl 8)) +
                            ',R' + IntToStr(GetBuf(I) And 7);
            Inc(I,2);
          End
          Else
          Begin
            St := St + 'SUB    ' + HexWord(GetBuf(I + 1)) +
                            ',R' + IntToStr(GetBuf(I) And 7);
            Inc(I);
          End;
        End;
776..831: If ((GetBuf(I) Shr 3) And 7) <> 7 Then
         St := St + 'SUB@   R' + IntToStr((GetBuf(I) Shr 3) And 7) +
                          ',R' + IntToStr(GetBuf(I) And 7)
        Else
        Begin
          If SDBD = 1 Then
          Begin
            St := St + 'SUBT   ' + HexWord((GetBuf(I + 1) And $FF) + (GetBuf(I + 2) Shl 8)) +
                            ',R' + IntToStr(GetBuf(I) And 7);
            Inc(I,2);
          End
          Else
          Begin
            St := St + 'SUBT   ' + HexWord(GetBuf(I + 1)) +
                            ',R' + IntToStr(GetBuf(I) And 7);
            Inc(I);
          End;
        End;
832..839: Begin
          If SDBD = 1 Then
          Begin
            St := St + 'CMP    ' + HexWord((GetBuf(I + 1) And $FF) + (GetBuf(I + 2) Shl 8)) +
                            ',R' + IntToStr(GetBuf(I) And 7);
            Inc(I,2);
          End
          Else
          Begin
            St := St + 'CMP    ' + HexWord(GetBuf(I + 1)) +
                            ',R' + IntToStr(GetBuf(I) And 7);
            Inc(I);
          End;
        End;
840..895: If ((GetBuf(I) Shr 3) And 7) <> 7 Then
         St := St + 'CMP@   R' + IntToStr((GetBuf(I) Shr 3) And 7) +
                          ',R' + IntToStr(GetBuf(I) And 7)
        Else
        Begin
          If SDBD = 1 Then
          Begin
            St := St + 'CMPI   ' + HexWord((GetBuf(I + 1) And $FF) + (GetBuf(I + 2) Shl 8)) +
                            ',R' + IntToStr(GetBuf(I) And 7);
            Inc(I,2);
          End
          Else
          Begin
            St := St + 'CMPI   ' + HexWord(GetBuf(I + 1)) +
                            ',R' + IntToStr(GetBuf(I) And 7);
            Inc(I);
          End;
        End;
896..903: Begin
            If SDBD = 1 Then
            Begin
              St := St + 'AND    ' + HexWord((GetBuf(I + 1) And $FF) + (GetBuf(I + 2) Shl 8)) +
                              ',R' + IntToStr(GetBuf(I) And 7);
              Inc(I,2);
            End
            Else
            Begin
              St := St + 'AND    ' + HexWord(GetBuf(I + 1)) +
                              ',R' + IntToStr(GetBuf(I) And 7);
              Inc(I);
            End;
          End;
904..959: If ((GetBuf(I) Shr 3) And 7) <> 7 Then
           St := St + 'AND@   R' + IntToStr((GetBuf(I) Shr 3) And 7) +
                            ',R' + IntToStr(GetBuf(I) And 7)
          Else
          Begin
            If SDBD = 1 Then
            Begin
              St := St + 'ANDI   ' + HexWord((GetBuf(I + 1) And $FF) + (GetBuf(I + 2) Shl 8)) +
                              ',R' + IntToStr(GetBuf(I) And 7);
              Inc(I,2);
            End
            Else
            Begin
              St := St + 'ANDI   ' + HexWord(GetBuf(I + 1)) +
                              ',R' + IntToStr(GetBuf(I) And 7);
              Inc(I);
            End;
          End;
960..967: Begin
            If SDBD = 1 Then
            Begin
              St := St + 'XOR    ' + HexWord((GetBuf(I + 1) And $FF) + (GetBuf(I + 2) Shl 8)) +
                              ',R' + IntToStr(GetBuf(I) And 7);
              Inc(I,2);
            End
            Else
            Begin
              St := St + 'XOR    ' + HexWord(GetBuf(I + 1)) +
                              ',R' + IntToStr(GetBuf(I) And 7);
              Inc(I);
            End;
          End;
968..1023: If ((GetBuf(I) Shr 3) And 7) <> 7 Then
           St := St + 'XOR@   R' + IntToStr((GetBuf(I) Shr 3) And 7) +
                            ',R' + IntToStr(GetBuf(I) And 7)
          Else
          Begin
            If SDBD = 1 Then
            Begin
              St := St + 'XORI   ' + HexWord((GetBuf(I + 1) And $FF) + (GetBuf(I + 2) Shl 8)) +
                              ',R' + IntToStr(GetBuf(I) And 7);
              Inc(I,2);
            End
            Else
            Begin
              St := St + 'XORI   ' + HexWord(GetBuf(I + 1)) +
                              ',R' + IntToStr (GetBuf(I) And 7);
              Inc(I);
            End;
          End;
    End; { Case }
    Inc(I);

    If GetJump(OldI + CartStart) Then St1 := HexWord(OldI + CartStart) + ' ' Else St1 := '     ';

    For J := 1 To 3 Do
    Begin
      If I - OldI >= J
       Then St1 := St1 + HexWord(GetBuf(OldI + J - 1)) + ' '
       Else St1 := St1 + '     ';
    End; { For J }

    If Print Then WriteLn(OutFile,St1,'  ',St);
  End; { While }
End; { Disassemble }


Begin
  If (ParamCount < 2) Or (ParamCount > 4) Then
  Begin
    WriteLn('Intellivision cartridge disassembler.');
    WriteLn('Usage: DIS1600 cartfile asmfile [base] [swap]');
    WriteLn;
    WriteLn('  Where "base" is a hexadecimal digit');
    Exit;
  End;
  BufSel  := GlobalAlloc(GMEM_FIXED Or GMEM_ZEROINIT,CartSize * 2);
  PBuf    := GlobalLock(BufSel);
  GetMem(PJump,CartSize);
  InFileName  := UpperCase(ParamStr(1));
  OutFileName := UpperCase(ParamStr(2));
  Assign(InFile,InFileName);
  Reset(InFile,1);
  Loaded  := FileSize(InFile) Div 2;
  Loading := Loaded * 2;
  I := 3;
  While I <= ParamCount Do
  Begin
    St := UpperCase(ParamStr(I));
    If St = 'SWAP' Then Swap := True;
    If (Length(St) = 1) And (St[1] In ['0'..'9','A'..'F']) Then
    Begin
      If St[1] In ['0'..'9']
       Then CartStart := (Ord(St[1]) - Ord('0')) * $1000
       Else CartStart := (Ord(St[1]) - Ord('A') + 10) * $1000;
    End;
    Inc(I);
  End; { While }
  I := 0;
  Repeat
    If FileSize(InFile) - FilePos(InFile) >= 32768
     Then Loading := 32768
     Else Loading := FileSize(InFile) - FilePos(InFile);
    P := Ptr(Seg(PBuf^) + (I Shr 1) * SelectorInc,(I And 1) * 32768);
    BlockRead(InFile,P^,Loading);

    { Swap bytes if necessary }

{    If Pos('.BIN',InFileName) <> 0 Then}
    If Swap Then
    Begin

      WriteLn('Swapping...');
      Asm
        LES   DI,DWORD PTR P
        MOV   CX,WORD PTR Loading
@L1:
        MOV   AX,WORD PTR [ES:DI]
        XCHG  AH,AL
        MOV   WORD PTR [ES:DI],AX
        ADD   DI,2
        LOOP  @L1
      End; { Asm }
    End;

    Inc(I);
  Until FilePos(InFile) = FileSize(InFile);
  Close(InFile);
  Assign(OutFile,OutFileName);
  ReWrite(OutFile);
  FillChar(PJump^,CartSize,#0);
  SetJump(CartStart);
  WriteLn('Pass 1');
  Disassemble(False);
  WriteLn;
  WriteLn('Pass 2');
  Disassemble(True);
  Close(OutFile);
  FreeMem(PJump,CartSize);
  GlobalUnlock(BufSel);
  GlobalFree(BufSel);
End.
