Program IntvDOS;

{ Anyone looking at this coude should see Delphi-like procedure names.    }
{ This program originally began life as a Delphi 3 program, but I decided }
{ that it would be far easier to perfect the emulation first as a DOS     }
{ program and then port it back to Windows later (after porting PCAE).    }

Uses
  Crt,
  Dos,
  HexWrite,
  Objects,
  Keyboard,
  IntvMnu,
  IntvSnd,
  IntvDbg,
  Time,
  IntvCntr,
  GameStat,
  Equation,
  WriteAVI,
  Strings,
  IVoice1,
  G320,
  VGAGUI,
  ICartROM;

Type
  SmallInt = Integer;
  WPtr = ^Word;

Const
  VGA_SEGMENT   = $A000;
  SC_INDEX      = $3C4;   { Sequence Controller Index register   }
  GC_INDEX      = $3CE;   { Graphics Controller Index register   }
  CRTC_INDEX    = $3D4;   { CRT Controller Index register        }
  MISC_OUTPUT   = $3C2;   { Miscellaneous Output Register        }
  MISC_INPUT    = $3CC;   { Miscellaneous Input Register         }
  MISCELLANEOUS = 6;      { Moscellaneous register index in GC   }
  MEMORY_MODE   = 4;      { Memory Mode register index in SC     }
  GRAPHICS_MODE = 5;      { Graphics Mode register index in GC   }
  MAX_SCAN_LINE = 9;      { Maximum Scan Line reg index in CRTC  }
  UNDERLINE     = $14;    { Underline Location reg index in CRTC }
  MODE_CONTROL  = $17;    { Mode Control register index in CRTC  }
  MAP_MASK      = 2;      { Map Mask register index in SC        }

  HORZ_TOTAL         = 0;
  HORZ_DISPLAY_END   = 1;
  START_HORZ_BLANK   = 2;
  END_HORZ_BLANK     = 3;
  START_HORZ_RETRACE = 4;
  END_HORZ_RETRACE   = 5;
  VERT_TOTAL         = 6;
  OVERFLOW           = 7;
  START_VERT_RETRACE = $10;
  END_VERT_RETRACE   = $11;
  VERT_DISPLAY_END   = $12;
  CRTC_OFFSET        = $13;
  START_VERT_BLANK   = $15;
  END_VERT_BLANK     = $16;
  LINE_COMPARE       = $18;

  ECSKeyTable : Array[0..7,0..7] Of Byte =
   ((kLF    ,kCOMMA,kN ,kV ,kX ,kSPACE,0,0),          { 0-7   }
    (kPERIOD,kM    ,kB ,kC ,kZ ,kDN   ,0,0),          { 8-15  }
    (kSCOLON,kK    ,kH ,kF ,kS ,kUP   ,0,0),          { 16-23 }
    (kP     ,kI    ,kY ,kR ,kW ,kQ    ,0,0),          { 24-31 }
    (kTAB   ,kN9   ,kN7,kN5,kN3,kN1   ,0,0),          { 32-39 }
    (kN0    ,kN8   ,kN6,kN4,kN2,kRT   ,0,0),          { 40-47 }
    (kENTER ,kO    ,kU ,kT ,kE ,kRCTRL,0,0),          { 48-55 }
    (0      ,kL    ,kJ ,kG ,kD ,kA    ,kRSHIFT,0));   { 56-63 }

  { left,   comma, n, v, x, space, NULL,  NULL }
  { period, m,     b, c, z, down,  NULL,  NULL }
  { scolon, k,     h, f, s, up,    NULL,  NULL }
  { p,      i,     y, r, w, q,     NULL,  NULL }
  { esc,    9,     7, 5, 3, 1,     NULL,  NULL }
  { 0,      8,     6, 4, 2, right, NULL,  NULL }
  { enter,  o,     u, t, e, ctl,   NULL,  NULL }
  { NULL,   l,     j, g, d, a,     shift, NULL }

  ImportTime    = 30;
  ECSInvalidKey = 255;
  RepeatTime    = 80;

(*
  ASCII CHART: 32-127

   !"#$%&'()*+,-./
  0123456789:;<=>?
  @ABCDEFGHIJKLMNO
  PQRSTUVWXYZ[\]^_
  `abcdefghijklmno
  pqrstuvwxyz{|}~
*)

  ASCIIToECSUnshift : Array[0..255] Of Byte =
   (255,255,255,255,255,255,255,255,255,255,255,255,255, 48,255,255, { 00-0F }
    255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255, { 10-1F }
      5,255,255,255,255,255,255,255,255,255,255,255,  1,255,  8,255, { 20-2F }
     40, 37, 44, 36, 43, 35, 42, 34, 41, 33,255, 16,255,255,255,255, { 30-3F }
    255, 61, 10, 11, 60, 52, 19, 59, 18, 25, 58, 17, 57,  9,  2, 49, { 40-4F }
     24, 29, 27, 20, 51, 50,  3, 28,  4, 26, 12,255,255,255,255,255, { 50-5F }
    255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255, { 60-6F }
    255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255, { 70-7F }
    255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255, { 80-8F }
    255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255, { 90-9F }
    255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255, { A0-AF }
    255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255, { B0-BF }
    255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255, { C0-CF }
    255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255, { D0-DF }
    255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255, { E0-EF }
    255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255);{ F0-FF }

  ASCIIToECSShift : Array[0..255] Of Byte =
   (255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255, { 00-0F }
    255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255, { 10-1F }
    255,255, 44, 36, 43,  0,255, 45, 33, 40, 41, 35,255, 42,255, 34, { 20-2F }
    255,255,255,255,255,255,255,255,255,255, 16,255,  1, 37,  8, 13, { 30-3F }
    255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255, { 40-4F }
    255,255,255,255,255,255,255,255,255,255,255,255,255,255, 21,255, { 50-5F }
    255, 61, 10, 11, 60, 52, 19, 59, 18, 25, 58, 17, 57,  9,  2, 49, { 60-6F }
     24, 29, 27, 20, 51, 50,  3, 28,  4, 26, 12,255,255,255,255,255, { 70-7F }
    255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255, { 80-8F }
    255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255, { 90-9F }
    255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255, { A0-AF }
    255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255, { B0-BF }
    255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255, { C0-CF }
    255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255, { D0-DF }
    255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255, { E0-EF }
    255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255);{ F0-FF }

  Playback_Freq : Word = 44100;
  Version        = '1.0c';
  DiscSize = 90;
  DiscXPos = 645;
  DiscYPos = 220;
  Condition : Array[0..7] Of Byte = ($10{FF},$01,$02,$08,$04,$20,$40,$80);
  PreRead   : Array[0..7] Of SmallInt = (0,0,0,0,0,0,-1,0);
  PostRead  : Array[0..7] Of SmallInt = (0,0,0,0,1,1,0,1);
  PreWrite  : Array[0..7] Of SmallInt = (0,0,0,0,0,0,0,0);
  PostWrite : Array[0..7] Of SmallInt = (0,0,0,0,1,1,1,1);
  InterruptFlag = $7FF;  { Interrupt every 800h instructions }
{  InterruptCycles = 2000000 Div 60;}
{  InterruptCycles = 2114202 Div 60;}
{  InterruptCycles = 1891967 Div 60;}
{  InterruptCycles = 2250000 / 60;}
  InterruptCycles = 2000000 / 60;

  ECSPrintName = 'INTVDOS.PRN';

  CS_ADVANCE = $2000;

  SP_VFLIP      = $08000000;
  SP_HFLIP      = $04000000;
  SP_4YSIZE     = $02000000;
  SP_2YSIZE     = $01000000;
  SP_RESOLUTION = $00800000;
  SP_2XSIZE     = $00000400;
  SP_VISIBLE    = $00000200;
  SP_COLLISION  = $00000100;

  KP_1 = $81;
  KP_2 = $41;
  KP_3 = $21;
  KP_4 = $82;
  KP_5 = $42;
  KP_6 = $22;
  KP_7 = $84;
  KP_8 = $44;
  KP_9 = $24;
  KP_C = $88;
  KP_0 = $48;
  KP_E = $28;

  Side_Up = $A0;
  Side_BL = $60;
  Side_BR = $C0;

  Disc_S = $01;
  Disc_E = $02;
  Disc_N = $04;
  Disc_W = $08;

  Disc_NE = $16;
  Disc_NW = $1C;
  Disc_SW = $19;
  Disc_SE = $13;

  Disc_ENE = $06;
  Disc_NNE = $14;
  Disc_NNW = $0C;
  Disc_WNW = $18;
  Disc_WSW = $09;
  Disc_SSW = $11;
  Disc_SSE = $03;
  Disc_ESE = $12;

type
  TMouseButton = Record
    Left, Middle, Right: Boolean;
  End;
  TShiftState = Record
    Left, Right: Boolean;
  End;
  PScreen  = ^TScreen;
  TScreen  = Array[0..160 * 192 - 1 + 16] Of Byte;
  PScreenB = ^TScreenB;
  TScreenB = Array[0..20 * 96 - 1 + 16] Of Byte;
  PScreenC = ^TScreenC;
  TScreenC = Array[0..160 * 96 - 1 + 16] Of Byte;

Var
  GameFileName    : String;
  NewList         : Boolean;
  LeftController  : Word;
  RightController : Word;

  ECSLeftController  : Word;
  ECSRightController : Word;

  LeftDiscPos     : Word;
  RightDiscPos    : Word;
  LeftMouseDown   : Boolean;
  RightMouseDown  : Boolean;
  CurrentDir      : String;

  I,J             : Integer;
  T0,T1           : LongInt;

{ ------------------------ Emulator global variables ------------------------- }

  Interrupts  : Byte;
  DoubleByte  : Boolean;
  EBCA        : Byte;
  EBCI        : Boolean;
  IntvMemPtr  : CP1600Mem;
  Emulating   : Boolean;
  Regs        : CP1600Regs;
  Locations   : Array[0..1023] Of Word;
  StatusWord  : Word;                    { xxxxxxxxxxxxSZOC }
  Breakpoint  : LongInt;
  Breaking    : Boolean;
  ScreenColl  : PScreenC;
  ScreenCollB : PScreenB;
  SpriteX     : TSpriteLoc;
  SpriteY     : TSpriteLoc;
  LogFile     : System.Text;

  VoiceLogFile : System.Text;

  LogOutput   : Boolean;
  DoubleBuf   : PScreen;
  DoublePtr   : Pointer;

  OldKey      : Array[$00..$FF] Of Byte;
  Config      : ConfigRec;
  UseMenu     : Boolean;
  Top         : Integer;
  Sel         : Integer;
  DoSound     : Boolean;
  InsCount    : Word;
  SlowCount   : Word;
  Frames      : LongInt;
  Cycles      : Array[0..1023] Of Byte;
  Time0       : Double;
  IntPending  : Boolean;
  GameE       : Array[0..$FFF] Of Word;
  ECSE        : Array[0..$FFF] Of Word;
  HaltLine    : Integer;
  ResetSound  : Boolean;
  Importing   : Boolean;
  ImportFile  : File;
  ImportRead  : Boolean;
  ImportKey   : Byte;
  ImportCount : Integer;
  ImportCont  : Byte;
  ImportShift : Boolean;
  ECSSaveBuf  : Array[0..15] Of Byte;
  ECSSaveBufI : Integer;                   { Index into save buffer }
  ECSCassFile : File;
  ECSSave     : Boolean;
  ECSLoad     : Boolean;
  ECSLoadable : Boolean;
  ECSPrint    : Boolean;
  DoSlowDown  : Boolean;
  ECSKey      : Boolean;
  ECSPCKey    : Integer;
  ECSDelay    : Integer;
  ECSKeyList  : Array[0..255] Of Byte;
  ReadMem     : Boolean;
  WriteMem    : Boolean;
  RWMemLoc    : Word;
  AVIFile     : TAVIFile;

Procedure CheckAVIStream;
Begin
  If AVIFile.Opened Then AVIFile.WriteFrame(Ptr($A000,0));
End; { CheckAVIStream }

Procedure SlowDown(Milliseconds: Word);
Var
  T : LongInt;
  R : Double;

Begin
  R := Time0 + (Milliseconds / Config.FrameRate);
  Repeat
    T := Clock;
    If T < (R - 1000) Then T := Trunc(R);
  Until (T >= R);
  Time0 := R;
End; { SlowDown }

Procedure ResetClock;
Begin
  Time0 := Clock;
End; { ResetClock }

function ArcTan2(Y, X: Extended): Extended; Assembler;
asm
  FLD     Y
  FLD     X
  FPATAN
  FWAIT
end;

Function IntvMemW(Addr: Word): Word;
Begin
  IntvMemW := IntvMemPtr[Addr Shr 12]^[Addr And $FFF];
End; { IntvMemW }

Function UpperCase(St: String): String;
Var I: Integer;
Begin
  I := 1;
  While I <= Length(St) Do
  Begin
    St[I] := UpCase(St[I]);
    Inc(I);
  End; { While }
  UpperCase := St;
End; { UpperCase }

Procedure InitEmulator;
Var
  F          : File;
  GROM       : Array[0..2047] Of Byte;
  I,J        : LongInt;
  Game_Start : Word;
  St         : String;

Begin
  IVoice_Init(Voice,Playback_Freq);

  For I := 0    To 65535 Do IntvMemPtr[I Shr 12]^[I And $FFF] := $FC00;
  For I := $200 To $2EF  Do IntvMemPtr[I Shr 12]^[I And $FFF] := 0;
  For I := 0    To $32   Do IntvMemPtr[I Shr 12]^[I And $FFF] := 0;

  For I := $33  To $FF   Do IntvMemPtr[I Shr 12]^[I And $FFF] := $FFFF;

  FillChar(Regs,SizeOf(Regs),#0);
{  IntvMem[SegSize - 6] := 4;
  IntvMem[SegSize - 4] := $300;
  IntvMem[SegSize - 2] := 0;}
  DoubleByte           := False;
  StatusWord           := 0;
  Interrupts           := 0;
  InsCount             := 0;
  SlowCount            := 0;
  LeftDiscPos          := 0;
  RightDiscPos         := 0;
  LeftMouseDown        := False;
  RightMouseDown       := False;

  { Read the exec }

  If FileExists(CurrentDir + '\' + Config.Exec) Then
  Begin
    Assign(F,CurrentDir + '\' + Config.Exec);
    Reset(F,1);
    For I := 0 To (FileSize(F) Div 2) - 1 Do
    Begin
      BlockRead(F,IntvMemPtr[(EXEC_Loc + I) Shr 12]^[(EXEC_Loc + I) And $FFF],2);
      IntvMemPtr[(EXEC_Loc + I) Shr 12]^[(EXEC_Loc + I) And $FFF] :=
       IntvMemPtr[(EXEC_Loc + I) Shr 12]^[(EXEC_Loc + I) And $FFF] Shr 8 +
       IntvMemPtr[(EXEC_Loc + I) Shr 12]^[(EXEC_Loc + I) And $FFF] Shl 8;
    End; { For I }
    Close(F);
  End;

  { Read graphics ROM }

  If FileExists(CurrentDir + '\' + Config.GROM) Then
  Begin
    Assign(F,CurrentDir + '\' + Config.GROM);
    Reset(F,1);
    BlockRead(F,GROM,FileSize(F));
    Close(F);
  End;
  For I := 0 To 2047 Do IntvMemPtr[(GROM_Loc + I) Shr 12]^[(GROM_Loc + I) And $FFF] := GROM[I];

  { Read Intellivoice ROM }

  If FileExists(CurrentDir + '\' + Config.IVoiceROM) Then
  Begin
    Assign(F,CurrentDir + '\' + Config.IVoiceROM);
    Reset(F,1);
    BlockRead(F,Mask,FileSize(F));
    Close(F);
  End;

  { Read the game }

  If GameFileName <> '' Then
  Begin
    Assign(F,GameFileName);
    Reset(F,1);
    If (UpperCase(Copy(GameFileName,Length(GameFileName) - 3,4)) <> '.ROM') Or
       Not ICartROM_Load(F,IntvMemPtr,True) Then
    Begin
      Seek(F,0);
      I := StrLen(ProfileRec^.MemStr);   { Necessary to copy into LongInt! }
      If (ProfileRec <> Nil) And
         (StrLen(ProfileRec^.MemStr) > 0) And
         (FileSize(F) >= I * $2000) Then
      Begin
        St := StrPas(ProfileRec^.MemStr);
        For J := 1 To Length(St) Do
        Begin
          Case UpCase(St[J]) Of
            '0'..'9': Game_Start := (Ord(UpCase(St[J])) - Ord('0')) * $1000;
            'A'..'F': Game_Start := (Ord(UpCase(St[J])) - Ord('A')) * $1000 + $A000;
          End; { Case }
          For I := 0 To $FFF Do
          Begin
            BlockRead(F,IntvMemPtr[(Game_Start + I) Shr 12]^[(Game_Start + I) And $FFF],2);
            IntvMemPtr[(Game_Start + I) Shr 12]^[(Game_Start + I) And $FFF] :=
             IntvMemPtr[(Game_Start + I) Shr 12]^[(Game_Start + I) And $FFF] Shr 8 +
             IntvMemPtr[(Game_Start + I) Shr 12]^[(Game_Start + I) And $FFF] Shl 8;
          End; { For I }
        End; { For J }
      End
      Else
      Begin
        For I := 0 To (FileSize(F) Div 2) - 1 Do
        Begin
          Case Cart Of
            Cart4:
            Begin
              BlockRead(F,IntvMemPtr[($4800 + I) Shr 12]^[($4800 + I) And $FFF],2);
              IntvMemPtr[($4800 + I) Shr 12]^[($4800 + I) And $FFF] :=
               (IntvMemPtr[($4800 + I) Shr 12]^[($4800 + I) And $FFF] Shr 8) +
               (IntvMemPtr[($4800 + I) Shr 12]^[($4800 + I) And $FFF] Shl 8);
            End;
            Cart5,CartECS:
            Begin
              If (FileSize(F) Shr 1) <= $B000
               Then
               Begin
                 BlockRead(F,IntvMemPtr[(Game_Loc + I) Shr 12]^[(Game_Loc + I) And $FFF],2);
                 IntvMemPtr[(Game_Loc + I) Shr 12]^[(Game_Loc + I) And $FFF] :=
                  IntvMemPtr[(Game_Loc + I) Shr 12]^[(Game_Loc + I) And $FFF] Shr 8 +
                  IntvMemPtr[(Game_Loc + I) Shr 12]^[(Game_Loc + I) And $FFF] Shl 8;
               End
               Else
               Begin
                 Game_Start := $5000 - ((FileSize(F) Shr 1) - $B000);
                 BlockRead(F,IntvMemPtr[(Game_Start + I) Shr 12]^[(Game_Start + I) And $FFF],2);
                 IntvMemPtr[(Game_Start + I) Shr 12]^[(Game_Start + I) And $FFF] :=
                  IntvMemPtr[(Game_Start + I) Shr 12]^[(Game_Start + I) And $FFF] Shr 8 +
                  IntvMemPtr[(Game_Start + I) Shr 12]^[(Game_Start + I) And $FFF] Shl 8;
               End;
            End;
          End; { Case }
        End; { For I }
      End;
    End;
    Close(F);

    { Save game E000-EFFF, in case the game is World Series Baseball }

    Move(IntvMemPtr[$E]^[0],GameE,SizeOf(GameE));
  End;

  { Read the ECS ROM into 2000h-2FFFh, 7000h-7FFFh, and E000h-EFFFh }

  If Cart = CartECS Then
  Begin
    Assign(F,CurrentDir + '\' + Config.ECS);
    Reset(F,1);
    For I := 0 To $FFF Do
    Begin
      BlockRead(F,IntvMemPtr[($2000 + I) Shr 12]^[($2000 + I) And $FFF],2);
      IntvMemPtr[($2000 + I) Shr 12]^[($2000 + I) And $FFF] :=
       IntvMemPtr[($2000 + I) Shr 12]^[($2000 + I) And $FFF] Shr 8 +
       IntvMemPtr[($2000 + I) Shr 12]^[($2000 + I) And $FFF] Shl 8;
    End; { For I }
    For I := 0 To $FFF Do
    Begin
      BlockRead(F,IntvMemPtr[($7000 + I) Shr 12]^[($7000 + I) And $FFF],2);
      IntvMemPtr[($7000 + I) Shr 12]^[($7000 + I) And $FFF] :=
       IntvMemPtr[($7000 + I) Shr 12]^[($7000 + I) And $FFF] Shr 8 +
       IntvMemPtr[($7000 + I) Shr 12]^[($7000 + I) And $FFF] Shl 8;
    End; { For I }
    For I := 0 To $FFF Do
    Begin
      BlockRead(F,IntvMemPtr[($E000 + I) Shr 12]^[($E000 + I) And $FFF],2);
      IntvMemPtr[($E000 + I) Shr 12]^[($E000 + I) And $FFF] :=
       IntvMemPtr[($E000 + I) Shr 12]^[($E000 + I) And $FFF] Shr 8 +
       IntvMemPtr[($E000 + I) Shr 12]^[($E000 + I) And $FFF] Shl 8;
    End; { For I }
    Close(F);

    { Save ECS E000-EFFF, in case the game is World Series Baseball }

    Move(IntvMemPtr[$E]^[0],ECSE,SizeOf(ECSE));
  End;

  { Initialize the PC }

  Regs[7] := Boot_Loc;

  LeftController     := $FF;
  RightController    := $FF;
  ECSLeftController  := $FF;
  ECSRightController := $FF;
End; { InitEmulator }

Procedure FormPaint; Far; Forward;

Procedure GetECSControllers;
Var
  I,J     : Integer;
  W_00F8  : Word;
  W_00FE  : Word;
  Found   : Boolean;
  Ch      : Char;
  Shift   : Boolean;
  ECSCode : Integer;

Begin
{
  If ECSKey
   Then WriteOut(0,0,'ECSKey = TRUE',2)
   Else WriteOut(0,0,'ECSKey = FALSE',1);
  If Importing
   Then WriteOut(0,8,'Importing = TRUE',2)
   Else WriteOut(0,8,'Importing = FALSE',1);
  If ECSSave
   Then WriteOut(0,16,'ECSSave = TRUE',2)
   Else WriteOut(0,16,'ECSSave = FALSE',1);
  If ECSLoad
   Then WriteOut(0,24,'ECSLoad = TRUE',2)
   Else WriteOut(0,24,'ECSLoad = FALSE',1);
}

  ECSLeftController  := $FF;
  ECSRightController := $FF;

  W_00F8 := IntvMemPtr[0]^[$00F8];
  W_00FE := IntvMemPtr[0]^[$00FE];

  { Look for a key that has been pressed }

  Found := False;
  I     := 0;
  While (I <= 255) And Not Found Do
  Begin
    If (Key[I] <> 0) And (ECSKeyList[I] = 0) Then Found := True Else Inc(I);
  End; { While }
  If Not Found Then
  Begin
    If Key[ECSPCKey] <> 0 Then
    Begin
      I     := ECSPCKey;
      Found := True;
    End;
    If Not Found Then
    Begin
      I := 0;
      While (I <= 255) And Not Found Do
      Begin
        If Key[I] <> 0 Then Found := True Else Inc(I);
      End; { While }
    End;
  End;
  Move(Key,ECSKeyList,SizeOf(ECSKeyList));

  { If a key has been pressed, find out the ASCII code }

  If Found Then
  Begin
    ECSPCKey := I;
    If (Key[kLSHIFT] <> 0) Or (Key[kRSHIFT] <> 0)
     Then Ch := ASCIITranslationShift[ECSPCKey]
     Else Ch := ASCIITranslation[ECSPCKey];

    { If the character is a letter, swap upper- and lower-case so that }
    { upper case is the default                                        }

    If Ch In ['A'..'Z'] Then Ch := Char(Ord(Ch) + 32)
    Else If Ch In ['a'..'z'] Then Ch := UpCase(Ch);

    { Lots of characters are mapped to <space> by default.  Only allow this }
    { if the space bar was depressed.                                       }

    If (Ch = ' ') And (ECSPCKey <> kSPACE) Then Ch := #0;

    { Special cases for control characters }

    Case ECSPCKey Of
     kTAB: Begin
             ECSCode := 32;
             Shift   := False;
           End;
  kEENTER: Begin                      { Only use main enter key }
             ECSCode := ECSInvalidKey;
             Shift   := False;
           End;
   kENTER: Begin
             ECSCode := 48;
             Shift   := False;
           End;
 kBACKSPC,
      kLF: Begin
             ECSCode := 0;
             Shift   := False;
           End;
      kRT: Begin
             ECSCode := 45;
             Shift   := False;
           End;
      kUP: Begin
             ECSCode := 21;
             Shift   := False;
           End;
      kDN: Begin
             ECSCode := 13;
             Shift   := False;
           End;
   kLCTRL,
   kRCTRL: Begin                      { Ctl by itself doesn't do anything }
             ECSCode := 53;
             Shift   := False;
           End;
  kLSHIFT,
  kRSHIFT: Begin                      { Shift by itself doesn't do anything }
             ECSCode := ECSInvalidKey;
             Shift   := False;
           End;
    Else

      { Find out the ECS key code and whehter the ECS shift key is needed }

      If ASCIIToECSUnshift[Ord(Ch)] <> ECSInvalidKey Then
      Begin
        Shift   := False;
        ECSCode := ASCIIToECSUnshift[Ord(Ch)];
      End
      Else
      If ASCIIToECSShift[Ord(Ch)] <> ECSInvalidKey Then
      Begin
        Shift   := True;
        ECSCode := ASCIIToECSShift[Ord(Ch)];
      End
      Else
      Begin
        Shift   := False;
        ECSCode := ECSInvalidKey;
      End;
    End; { Case }

    { Get the key entered }

    If (ECSCode <> 255) And Not Importing Then
    Begin

      { If the key is being held down, wait for the auto-repeat delay }
      { to elapse                                                     }

      If Not ECSKey Then
      Begin
        If (ImportKey = ECSCode)   And
           (ImportShift = Shift)   And
           (ECSDelay < RepeatTime) Then Inc(ECSDelay)
        Else
        Begin
          Importing   := True;       { Inputting a key                       }
          ImportRead  := False;      { Not reading from a file               }
          ImportKey   := ECSCode;    { ECS key code                          }
          ImportCount := 0;          { Just starting the key input           }
          ImportShift := Shift;      { ECS Shift key needed/not needed       }
          ECSKey      := True;       { Key is being typed in (not from file) }
          ECSDelay    := 0;          { Reset auto-repeat delay               }
        End;
      End;
    End;
  End
  Else
  Begin

    { If no key is pressed and we're not importing from a file, blank the }
    { key variables so we know if a key was released.  This is important  }
    { for implementing auto-repeat.                                       }

    If ECSKey Then Importing := False;     { No keys being input          }
    ECSKey   := False;         { No key is being typed in     }
    ECSPCKey := 0;             { No PC keyboard key being pressed  }
    ECSDelay := 0;             { Reset auto-repeat delay      }
    If Not Importing Then
    Begin
      ImportRead  := False;         { Not reading from a file      }
      ImportKey   := ECSInvalidKey; { No key being pressed         }
      ImportCount := 0;             { Reset the input time counter }
      ImportShift := False;         { ECS Shift key not being used }
    End;
  End;

(*
  For J := 0 To 7 Do
  Begin
    For I := 0 To 7 Do
    Begin
      If ((W_00FE And (1 Shl J)) = 0) And
         ((W_00F8 And $C0) = $40) And
         (ECSKeyTable[I,J] <> 0) And
         (Key[ECSKeyTable[I,J]] <> 0) Then
       ECSLeftController := ECSLeftController  And ($FF Xor (1 Shl I));
    End; { For I }
  End; { For J }
*)
  IntvMemPtr[0]^[$00FE] := IntvMemPtr[0]^[$00FE] Or $FF00;
  IntvMemPtr[0]^[$00FF] := IntvMemPtr[0]^[$00FF] Or $FF00;
End; { GetECSControllers }

Function CanWrite(Addr: Word): Boolean;
Var Result: Boolean;
Begin
  Result := True;

  { Prevent EXEC ROM from being overwritten }

  If (Addr >= $1000) And (Addr <= $1FFF) Then Result := False;
  CanWrite := Result;
End; { CanWrite }

Var
  IllegalWrite : Word;
  IllegalRead  : Word;
  IllegalRegs  : Array[0..7] Of Word;

Const  _81Write : Word = 0;


{$F+}
Procedure Handle_IO_Write(Addr,Value: Word);
Var
  I         : Word;
  ECSEnable : Word;
  St        : String;
  F         : File;

Begin
  ReadMem  := False;
  WriteMem := True;
  RWMemLoc := Addr;
{
  If ((Addr >= $33)   And (Addr <= $FF))   Or
     ((Addr >= $360)  And (Addr <= $FFF))  Or
     ((Addr >= $2000) And (Addr <= $2FFF)) Or
     ((Addr >= $2000) And (Addr <= $37FF)) Or
     ((Addr >= $3C00) And (Addr <= $FFFF)) Then
  Begin
    Emulating      := False;
    IllegalWrite   := Addr;
    IllegalRead    := 0;
    IllegalRegs[0] := Regs[0];
    IllegalRegs[1] := Regs[1];
    IllegalRegs[2] := Regs[2];
    IllegalRegs[3] := Regs[3];
    IllegalRegs[4] := Regs[4];
    IllegalRegs[5] := Regs[5];
    IllegalRegs[6] := Regs[6];
    IllegalRegs[7] := Regs[7];
  End;
}
{  If (Addr = $033D) And LogOutput Then WriteLn(LogFile,'======= [033D] = ',HexWord(IntvMemW($033D)));}


{  If (Addr = $031B) And LogOutput Then WriteLn(LogFile,'======= [031B] = ',HexWord(IntvMemW($031B)));
  If (Addr = $031C) And LogOutput Then WriteLn(LogFile,'======= [031C] = ',HexWord(IntvMemW($031C)));}
(*
  If (Addr >= $031B) And (Addr <= $032F) And LogOutput Then
  Begin
    Write(LogFile,'[',HexWord(Addr),'] ');
    For I := $031B To $032F Do Write(LogFile,HexWord(I),' ');
    WriteLn(LogFile);
    Write(LogFile,'====== ');
    For I := $031B To $032F Do Write(LogFile,HexWord(IntvMemW(I)),' ');
    WriteLn(LogFile);
  End;
*)
{  If Addr = $0020 Then Form1.FormPaint(Form1);}

  If Addr < 8 Then
  Begin
{    If (IntvMemPtr[0]^[Addr] And $200) <> 0 Then}
    Begin
      SpriteX[Addr] := Integer(IntvMemPtr[0]^[Addr]     And $FF) - 8;
      SpriteY[Addr] := Integer(IntvMemPtr[0]^[Addr + 8] And $7F) * 2 - 16;
{      If SpriteX[Addr] < 0 Then SpriteX[Addr] := 0;
      If SpriteY[Addr] < 0 Then SpriteY[Addr] := 0;}
{      Form1.FormPaint(Form1);}
    End;
  End
  Else
   If Addr < 16 Then
   Begin
     I := Addr - 8;
{     If (IntvMemPtr[0]^[I] And $200) <> 0 Then}
     Begin
       SpriteY[I] := Integer(IntvMemPtr[0]^[Addr] And $7F) * 2 - 16;
{       If SpriteY[I] < 0 Then SpriteY[I] := 0;}
{       Form1.FormPaint(Form1);}
     End;
   End
   Else
   Begin
     If Addr < $200 Then
     Begin
       If Addr = $0021 Then ScreenMode := smForeBack;
       If (Cart = CartECS) And
          ((Addr = $00F8) Or
           (Addr = $00FE) Or
           (Addr = $00FF)) Then GetECSControllers;
       If (Addr >= $100) And (Addr <= $1FF) Then IntvMemPtr[0]^[Addr] := IntvMemPtr[0]^[Addr] And $FF;
       If (Addr >= $1F0) And (Addr <= $1FD) And Config.DoSound Then WriteToPSG(Addr - $1F0,IntvMemPtr[0]^[Addr],0);
       If Cart = CartECS Then
       Begin
         If (Addr >= $F0) And (Addr <= $FF) Then IntvMemPtr[0]^[Addr] := IntvMemPtr[0]^[Addr] And $FF;
         If (Addr >= $F0) And (Addr <= $FD) And Config.DoSound Then WriteToPSG(Addr - $F0,IntvMemPtr[0]^[Addr],1);
       End
       Else
       Begin
         If (Addr >= $F0) And (Addr <= $FF) Then IntvMemPtr[0]^[Addr] := $FFFF;
       End;

       { Intellivoice }

       If (Addr = $80) Or (Addr = $81) Then IVoice_Wr(Voice,Addr - $80,Value);

       { ECS BIOS will only write to  [E1h] (cassette) if ([E0h] and 2) <> 0 }
       { ECS BIOS will only read from [E1h] (cassette) if ([E0h] and 1) <> 0 }

       If ((Addr >= $33) And (Addr <= $DF)) Or
          ((Addr >= $E3) And (Addr <= $EF)) Then
        IntvMemPtr[0]^[Addr] := $FFFF;

       If Cart <> CartECS Then
       Begin
         If (Addr >= $E0) And (Addr <= $E2) Then IntvMemPtr[0]^[Addr] := $FFFF;
       End
       Else
       Begin

         { ECS cassette ports are 8-bit ports }

         If (Addr >= $E0) And (Addr <= $EF) Then
          IntvMemPtr[0]^[Addr] := IntvMemPtr[0]^[Addr] And $FF;


         { 00E0h .... ECS cassette status (R/W) }
         { 00E1h .... ECS cassette data   (R/W) }
         { 00E2h .... ECS cassette control (W)  }

         { ECS cassette status port }
         {                          }
         { bit assignments          }
         { MSB 7 ..... unknown      }
         {     6 ..... unknown      }
         {     5 ..... unknown      }
         {     4 ..... unknown      }
         {     3 ..... unknown      }
         {     2 ..... unknown      }
         {     1 ..... write enable }
         { LSB 0 ..... read enable  }

         If Addr = $00E0 Then IntvMemPtr[0]^[Addr] := IntvMemPtr[0]^[Addr] Or 3;

         { ECS cassette data port }

         If Addr = $00E1 Then
         Begin
           ECSSave := True;
{           If ECSSave Then
           Begin}
             If Not ECSPrint Then
             Begin
               If ECSSaveBufI < 16 Then
               Begin
                 ECSSaveBuf[ECSSaveBufI] := Value;
                 Inc(ECSSaveBufI);

                 { If 16 words have been written, extract the title and create }
                 { the output file                                             }

                 If ECSSaveBufI = 16 Then
                 Begin
                   St := Chr(ECSSaveBuf[12]) + Chr(ECSSaveBuf[13]) +
                         Chr(ECSSaveBuf[14]) + Chr(ECSSaveBuf[15]);
                   Assign(ECSCassFile,St);
                   ReWrite(ECSCassFile,1);
                   BlockWrite(ECSCassFile,ECSSaveBuf,SizeOf(ECSSaveBuf));
                 End;
               End
               Else BlockWrite(ECSCassFile,Value,1);
             End
             Else
             Begin
               If ECSSaveBufI = 0 Then
               Begin
                 St := FileDialog('Print to file','*.*');
                 If St = '' Then St := ECSPrintName;
                 Assign(ECSCassFile,St);
                 ReWrite(ECSCassFile,1);
                 ECSSaveBufI := 1;
               End;
               BlockWrite(ECSCassFile,Value,1);
             End;
{           End;}
         End;

         { ECS cassette control port }

         If Addr = $00E2 Then
         Begin

           { If an output file is already open, close it }

           If ECSSave Then
           Begin
             Close(ECSCassFile);
             ECSSave     := False;
             ECSPrint    := False;
             ECSSaveBufI := 0;
             ResetClock;
           End;

           { If an input file is already open, close it }

           If ECSLoad Then
           Begin
             If ECSLoadable Then Close(ECSCassFile);
             ECSLoad     := False;
             ECSLoadable := False;
             ResetClock;
           End;

           { See if we're writing to the cassette or to the printer }

           If Value = $0039 Then
           Begin
             ECSSaveBufI := 0;
{             ECSSave     := True;}
             ECSPrint    := False;
           End
           Else
           If Value = $0023 Then
           Begin
             ECSSaveBufI := 0;
{             ECSSave     := True;}
             ECSPrint    := True;
           End;
         End;
       End;

{
       If Addr = $81 Then
       Begin
         If (Value And $400) <> 0
          Then Write(VoiceLogFile,'C ')
          Else Write(VoiceLogFile,HexWord(Value And $3FF) + ' ');
       End
       Else If Addr = $80 Then
       Begin
         Write(VoiceLogFile,'<' + HexByte(Value And $FF) + '> ');
       End;
}


(*
       If LogOutput And ((Addr >= $80) And (Addr <= $FF)) Then
       Begin
         St := '(' +
               HexWord(Addr) + ')       ' +
               HexWord(Value) +
               '   --- ';
         For I := 0 To 7 Do St := St + HexWord(Regs[I]) + ' ';
         If Addr = $81 Then
         Begin
           Inc(_81Write);
           St := St + '  <' + HexWord(_81Write) + '>';
           If (Value And $400) <> 0 Then St := St + '    Clear FIFO';
         End;
         If (Value And $400) = 0 Then WriteLn(LogFile,St);
       End;

       If (Addr = $81) And (VoiceFRead <> VoiceFWrite) Then
       Begin
         I            := (VoiceFWrite - 1) And 63;
         VoiceFIFO[I] := Value;
         VoiceFWrite  := (VoiceFWrite + 1) And 63;
       End;

       If VoiceReady
        Then IntvMemPtr[0]^[$80] := $8000
        Else IntvMemPtr[0]^[$80] := 0;
       IntvMemPtr[0]^[$81] := 0;
*)




(*
       IntvMemPtr[0]^[$80] := $8000;   { Signify ready to accept data }
       IntvMemPtr[0]^[$81] := $80;
*)





(*
   If LogOutput And (Addr < $400) Then
   Begin
     St := '(' + HexWord(Addr) + ')  ';
     K  := {Addr;}0;
     St := St + '= ' + HexWord(Value);
     K := Addr + 1;
     If St <> '' Then
     Begin
       St := HexWord(Regs[7]) + '---' + St;
       If K <= $1F Then
       Begin
         For J := K To $1F Do
         Begin
           St := St + '    ';
           If (J And 7) = 7 Then St := St + '-' Else St := St + ' ';
         End; { For J }
       End;

       While Length(St) < 39 Do St := St + ' ';
       For K := 0 To 7 Do St := St + ' ' + HexWord(Regs[K]);
       WriteLn(LogFile,St);
     End;
   End;
*)
     End
     Else
     Begin
       { The following line is needed for World Cup Soccer to work.  It    }
       { attempts to write to a memory location where there is no RAM, so  }
       { the emulator has to keep it at zero.  However, the ECS has RAM at }
       { this area, so the emulator has to allow the write in that case.   }

       If (Addr = $47CD) And (Cart <> CartECS) Then IntvMemPtr[4]^[$07CD] := 0;

       { Force high byte in GRAM to be zero }

       If (Addr >= $3800) And (Addr < $3800 + 64 * 8) Then
        IntvMemPtr[Addr Shr 12]^[Addr And $FFF] := IntvMemPtr[Addr Shr 12]^[Addr And $FFF] And $FF;

       { In the ECS, 4000-47FF is 8-bit memory }

       If (Addr >= $4000) And (Addr < $4800) And (Cart = CartECS) Then
        IntvMemPtr[4]^[Addr And $FFF] := IntvMemPtr[4]^[Addr And $FFF] And $FF;

       If (Addr = $EFFF) And (Value = $EA50) And (Cart = CartECS) Then
       Begin
         Move(GameE,IntvMemPtr[$E]^[0],SizeOf(GameE));
       End;
       If (Addr = $EFFF) And (Value = $EA51) And (Cart = CartECS) Then
       Begin
         Move(ECSE,IntvMemPtr[$E]^[0],SizeOf(ECSE));
       End;
(*
       If LogOutput Then
       Begin
         St := 'W (' +
               HexWord(Addr) + ')       ' +
               HexWord(Value) +
               '   --- ';
         For I := 0 To 6 Do St := St + HexWord(Regs[I]) + ' ';
         St := St + '<' + HexWord(Regs[7]) + '>';
         WriteLn(LogFile,St);
       End;
*)
     End;
  End;

  If LogOutput And (Addr >= $00E0) And (Addr <= $00EF) Then
  Begin
    St := 'W (' +
          HexWord(Addr) + ')       ' +
          HexWord(Value) +
          '   --- ';
    For I := 0 To 6 Do St := St + HexWord(Regs[I]) + ' ';
    St := St + '<' + HexWord(Regs[7]) + '>';
    WriteLn(LogFile,St);
  End;

End; { Handle_IO_Write }

Procedure Handle_IO_Read(Addr,Value: Word);
Var
  St    : String;
  C     : Char;
  I,J   : Integer;
  B     : Byte;

Begin
  ReadMem  := True;
  WriteMem := False;
  RWMemLoc := Addr;
{
  If ((Addr >= $33)   And (Addr <= $FF))   Or
     ((Addr >= $360)  And (Addr <= $FFF))  Or
     ((Addr >= $2000) And (Addr <= $2FFF)) Or
     ((Addr >= $2000) And (Addr <= $2FFF)) Or
     ((Addr >= $3C00) And (Addr <= $47FF)) Or
     ((Addr >= $4801) And (Addr <= $4FFF)) Or
     ((Addr >= $6000) And (Addr <= $6FFF)) Or
     ((Addr >= $7001) And (Addr <= $4FFF)) Then
  Begin
    Emulating      := False;
    IllegalWrite   := 0;
    IllegalRead    := Addr;
    IllegalRegs[0] := Regs[0];
    IllegalRegs[1] := Regs[1];
    IllegalRegs[2] := Regs[2];
    IllegalRegs[3] := Regs[3];
    IllegalRegs[4] := Regs[4];
    IllegalRegs[5] := Regs[5];
    IllegalRegs[6] := Regs[6];
    IllegalRegs[7] := Regs[7];
  End;
}

  If Addr = $0021 Then ScreenMode := smColorStack;

{  If Addr < $0080 Then IntvMemPtr[0]^[Addr] := IntvMemPtr[0]^[Addr] Or $C000;}

  If Cart = CartECS Then
  Begin

    { Read from ECS cassette port }

    If Addr = $00E1 Then
    Begin
      If Not ECSLoad Then
      Begin
        ECSLoad := True;

        { The four-letter file name for CLOD and CVRF is stored internally }
        { at 4080h-4083h                                                   }

        St := Chr(IntvMemPtr[4]^[$0080]) + Chr(IntvMemPtr[4]^[$0081]) +
              Chr(IntvMemPtr[4]^[$0082]) + Chr(IntvMemPtr[4]^[$0083]);
        If CanOpenFile(St) Then
        Begin
          Assign(ECSCassFile,St);
          Reset(ECSCassFile,1);
          ECSLoadable := True;
        End
        Else ECSLoadable := False;
      End;
      If ECSLoad Then
      Begin
        If ECSLoadable Then
        Begin
          If Not Eof(ECSCassFile) Then
          Begin
            BlockRead(ECSCassFile,B,1);
            IntvMemPtr[0]^[Addr] := B;
          End;
        End
        Else IntvMemPtr[0]^[Addr] := 0;
      End;
    End;

    { Read ECS controllers.  Also supports importing ECS Basic text files }
    { by automatically typing their contents into the emulator.           }

    If ((Addr = $00FE) Or
        (Addr = $00FF)) Then
    Begin
      GetECSControllers;
      If Importing Then
      Begin

        { The last char was input; get another }

        If ImportRead Then
        Begin
          ECSKey      := False;         { No key currently being typed in   }
          ImportKey   := ECSInvalidKey; { No key currently being typed in   }
          ImportShift := False;         { ECS Shift key not needed          }
          ECSDelay    := 0;             { Reset auto-repeat delay           }
          ECSPCKey    := 0;             { No PC keyboard key being pressed  }
          If Not Eof(ImportFile) Then
          Begin
            BlockRead(ImportFile,C,1);

            { Try to find the corresponding key }

            If ASCIIToECSUnshift[Byte(C)] <> 255 Then
            Begin
              ImportKey   := ASCIIToECSUnshift[Byte(C)];
              ImportShift := False;
              ImportRead  := False;
            End
            Else
            If ASCIIToECSShift[Byte(C)] <> 255 Then
            Begin
              ImportKey   := ASCIIToECSShift[Byte(C)];
              ImportShift := True;
              ImportRead  := False;
            End;
          End
          Else
          Begin
            Close(ImportFile);
            Importing   := False;
            ImportRead  := False;
            ECSKey      := False;         { No key currently being typed in   }
            ImportKey   := ECSInvalidKey; { No key currently being typed in   }
            ImportShift := False;         { ECS Shift key not needed          }
            ECSDelay    := 0;             { Reset auto-repeat delay           }
            ECSPCKey    := 0;             { No PC keyboard key being pressed  }
            ResetClock;
          End;
        End;

        { See if the ECS can read the char }

        ECSLeftController := $FF;

        If Importing And Not ImportRead Then
        Begin
          J := ImportKey And 7;
          I := (ImportKey Shr 3) And 7;
          If (ImportCount >= (ImportTime Div 2)) And
             ((IntvMemPtr[0]^[$00F8] And $C0) = $40) Then
          Begin
            If ImportShift And ((IntvMemPtr[0]^[$00FE] And (1 Shl 6)) = 0) Then
             ECSLeftController := ECSLeftController And $7F;
            If ((IntvMemPtr[0]^[$00FE] And (1 Shl J)) = 0){ And
               ((IntvMemPtr[0]^[$00F8] And $C0) = $40)} And
               (ImportCount >= 3 * (ImportTime Div 4)) Then
            Begin
              ECSLeftController := $FF Xor (1 Shl I);
              ImportCont         := ECSLeftController;
              If ImportCount >= ImportTime Then
              Begin
                ImportCount := 0;
                If ECSKey Then
                Begin

                  { Don't change ImportKey or ImportShift because we want }
                  { to remember the key for auto-repeat                   }

                  Importing   := False;   { No more character input }
                  ImportRead  := False;   { Not reading from file   }
                  ECSDelay    := 0;       { Reset auto-repeat delay }
                  ECSKey      := False;
                End
                Else ImportRead  := True;
              End;
            End;
          End;
          Inc(ImportCount);
        End;
        If (IntvMemPtr[0]^[$00F8] And $40) = 0 Then IntvMemPtr[0]^[$00FE] := ECSRightController Or $FF00;
        If (IntvMemPtr[0]^[$00F8] And $80) = 0 Then IntvMemPtr[0]^[$00FF] := ECSLeftController Or $FF00;
      End;
    End;
  End;
{
  If Addr = $0321 Then
  Begin
    Breaking   := True;
    Breakpoint := Regs[7];
  End;
}
  { Intellivoice }

  If (Addr = $80) Or (Addr = $81) Then
   IntvMemPtr[0]^[Addr] := IVoice_Rd(Voice,Addr - $80);

{
  If LogOutput And ((Addr >= $80) And (Addr <= $FF)) Then
  Begin
    St := '[' + HexWord(Addr) + '] ' + HexWord(Value) + '         --- ' + HexWord(Regs[7]);
    WriteLn(LogFile,St);
  End;
}

  If LogOutput And (Addr >= $00E0) And (Addr <= $00E2) Then
  Begin
    St := 'R (' +
          HexWord(Addr) + ')       ' +
          HexWord(Value) +
          '   --- ';
    For I := 0 To 6 Do St := St + HexWord(Regs[I]) + ' ';
    St := St + '{' + HexWord(Regs[7]) + '}';
    WriteLn(LogFile,St);
  End;

End; { Handle_IO_Read }
{$F-}

Procedure EventHandler;
Var
  Cap           : TCapability;
  Info          : TIntvControls;
  SwReset       : Byte;
  SwSelect      : Byte;
  Path          : PathStr;
  Dir           : DirStr;
  Name          : NameStr;
  Ext           : ExtStr;
  UPos          : Integer;
  RealName      : String;
  FileName      : String;
  St            : String;
  F             : File;

Begin
  Cap.Cont[1] := imAllCaps;
  Cap.Cont[2] := imAllCaps;
  Cap.Cont[3] := imAllCaps;
  Cap.Cont[4] := imAllCaps;
{
  Cap.KB_A    := imAllCaps;
  Cap.KB_B    := imAllCaps;
  Cap.SY_A    := imAllCaps;
  Cap.SY_B    := imAllCaps;
}
  { Initialize the info structure }

  Info.P[1]    := $FF;
  Info.P[2]    := $FF;
  Info.P[3]    := $FF;
  Info.P[4]    := $FF;
  Info.Console := 0;

  InterfaceHandler^.GetControllerInfo(Cap,Info);

  { Make sure that basic console switches work }

  If Key[kESC] <> 0 Then
  Begin
    Info.Console := Info.Console Or cfPower;
    Repeat Until Key[kESC] = 0;
  End;
  If Key[kF1]  <> 0 Then
  Begin
    GameStatus;
    FormPaint;
    ResetClock;
  End;
  If Key[kF2]  <> 0 Then
  Begin
    Repeat Until Key[kF2] = 0;
    FSplit(GameFileName,Dir,Name,Ext);
    QuickSave(IntvMemPtr,Handle_IO_Write,Handle_IO_Read,Regs,StatusWord,
              (ScreenMode = smForeBack),Name + '.GMS');
    FormPaint;
    ResetClock;
  End;
  If Key[kF4]  <> 0 Then
  Begin
    Repeat Until Key[kF4] = 0;
    FSplit(GameFileName,Dir,Name,Ext);
    QuickLoad(IntvMemPtr,Handle_IO_Write,Handle_IO_Read,Regs,StatusWord,
              Name + '.GMS');
    FormPaint;
    ResetClock;
  End;
  If (Key[kF7] <> 0) And (Cart = CartECS) And Not Importing Then
  Begin
    Repeat Until Key[kF7] = 0;
    If ImportBasicPgm(FileName) Then
    Begin
      Assign(ImportFile,FileName);
      Reset(ImportFile,1);
      ImportRead  := True;
      Importing   := True;
      ImportCount := 0;
      ImportCont  := $FF;
      ImportShift := False;
    End;
    FormPaint;
    ResetClock;
  End;
  If Key[kF8] <> 0 Then
  Begin
    Repeat Until Key[kF8] = 0;
    LoadGame(IntvMemPtr,Handle_IO_Write,Handle_IO_Read,Regs,StatusWord);
    FormPaint;
    ResetClock;
  End;
  If Key[kF9] <> 0 Then
  Begin
    Repeat Until Key[kF9] = 0;
    ScreenCapture(Config.ExtraLines);
    FormPaint;
    ResetClock;
  End;
  If Key[kF10] <> 0 Then Info.Console := Info.Console Or cfReset;
  If Key[kF12] <> 0 Then
  Begin
    Repeat Until Key[kF12] = 0;
    DoSlowDown := Not DoSlowDown;
    ResetClock;
  End;
  If Key[kF11] <> 0 Then
  Begin
    Repeat Until Key[kF11] = 0;
    If Not AVIFile.Opened Then
    Begin
      St := UpperCase(FileDialog('Save to .AVI','*.AVI'));
      If CreateFile(F,St) Then
      Begin
        Close(F);
        AVIFile.Open(St,320,200,acRLE,exNone,Palette)
      End;
    End
    Else AVIFile.Close;
    ResetClock;
  End;

  { Check to see if we are streaming to an .AVI file }

  CheckAVIStream;

  { Get controller information }


  { Get console switch information }

  If (Info.Console And cfReset) <> 0 Then InitEmulator;

  { Copy info }


  { Check other special keys }




{
  GotoXY(1,1);
  For I := 0 To 7 Do Write(HexWord(Regs[I]),' ');

  Repeat
  Until Key[kSPACE] <> 0;
  Repeat
  Until Key[kSPACE] = 0;
}

  { Exiting }

  If (Info.Console And cfPower) <> 0 Then
  Begin
    If Emulating Then NewList := True;
    Emulating  := False;
  End;

  LeftController     := Info.P[1];
  RightController    := Info.P[2];
  ECSLeftController  := Info.P[3];
  ECSRightController := Info.P[4];
(*
  W_00F8 := IntvMemPtr[0]^[$00F8];
  W_00FE := IntvMemPtr[0]^[$00FE];
  For J := 0 To 7 Do
  Begin
    For I := 0 To 7 Do
    Begin
      If ((W_00FE And (1 Shl J)) = 0) And
         ((W_00F8 And $C0) = $40) And
         (ECSKeyTable[I,J] <> 0) And
         (Key[ECSKeyTable[I,J]] <> 0) Then
      Begin
        ECSLeftController := ECSLeftController  And ($FF Xor (1 Shl I));
{        ECSRightController := ECSRightController And ($FF Xor (1 Shl I));}
      End;
    End; { For I }
  End; { For J }

  Move(Key,OldKey,SizeOf(Key));
*)
End; { EventHandler }

Function ValHex(St: String): LongInt;
Var
  Initial : LongInt;
  I       : SmallInt;
  Value   : LongInt;

Begin
  If St = '' Then
  Begin
    ValHex := -1;
    Exit;
  End;
  Value   := 0;
  St      := UpperCase(St);
  I       := (Length(St) - 1) * 4;
  Asm
    DB    _32BIT_OPERAND
    SUB   AX,AX
    MOV   AX,1
    MOV   CX,WORD PTR I
    DB    _32BIT_OPERAND
    SHL   AX,CL
    DB    _32BIT_OPERAND
    MOV   WORD PTR Initial,AX
  End; { Asm }
  For I := 1 To Length(St) Do
  Begin
    If St[I] In ['0'..'9'] Then Inc(Value,Initial * (Ord(St[I]) - Ord('0')))
     Else
      If St[I] In ['A'..'F'] Then Inc(Value,Initial * (Ord(St[I]) - Ord('A') + 10))
       Else
       Begin
         ValHex := -1;
         Exit;
       End;
    Initial := Initial Shr 4;
  End; { For I }
  ValHex := Value;
End; { ValHex }

{$F+}
Procedure FormPaint;
Var
  Color       : Word;
  BlockOut    : Word;
  BorderColor : LongInt;
  ColorStack  : Array[0..3] Of LongInt;
  I           : Integer;
  VertAddrOfs : Integer;

  Procedure DrawBacktab(OnBits: Boolean);
  Var
    _X,_Y,X,Y,Addr : Word;
    Addr2,Addr3    : Word;
    Addr4,Addr5    : Word;
    B              : Word;
    Card           : Word;
    Ch             : Word;
    Addr1          : Word;
    FCol,BCol      : Word;
    ColorStackPtr  : Word;
    ColoredSquares : Boolean;
    ClearSquare    : Boolean;
    CStack         : Word;

  Begin
    ColorStackPtr := 0;
    BCol          := ColorStack[0];
    For _Y := 0 To 11 Do
    Begin
      Addr2 := _Y * 160 * 16;
      Addr4 := _Y * 20 * 8;
      For _X := 0 To 19 Do
      Begin
        Addr3 := 0;
        Addr5 := 0;
        Addr  := BACKTAB + _Y * 20 + _X;
        Card  := IntvMemPtr[0]^[Addr];
        If ScreenMode = smColorStack Then
        Begin
          ColoredSquares := ((Card And $1800) = $1000);
          If Not ColoredSquares Then
          Begin
            FCol  := (Card And $7) + ((Card And $1000) Shr 9);
            Ch    := (Card Shr 3) And $FF;
            If (Card And $800) <> 0 Then Ch := Ch And $3F;
            If Ch > 212 Then Ch := 0;
            If (Card And CS_ADVANCE) <> 0 Then
             ColorStackPtr := (ColorStackPtr + 1) And 3;
            BCol := ColorStack[ColorStackPtr];
          End;
        End
        Else
        Begin
          ColoredSquares := False;
          FCol := (Card And $7);
          BCol := ((Card Shr  9) And 1) +
                  ((Card Shr  9) And 2) +
                  ((Card Shr 11) And 4) +
                  ((Card Shr  9) And 8);
          Ch    := (Card Shr 3) And $3F;
        End;

        If Not ColoredSquares Then
        Begin
          If (Card And $800) = 0
           Then Addr1 := GROM_Loc + Ch * 8
           Else Addr1 := GRAM_Loc + Ch * 8;
          Asm
            MOV   WORD PTR Y,8

            TEST  BYTE PTR OnBits,0FFh
            JZ    @DoOffBits
            MOV   CL,BYTE PTR FCol
            JMP   @YLoop
@DoOffBits:
            MOV   CL,BYTE PTR BCol
@YLoop:
            MOV   SI,WORD PTR Addr1
            SHR   SI,12
            SHL   SI,2
            LES   BX,DWORD PTR IntvMemPtr[SI]
            MOV   SI,WORD PTR Addr1
            AND   SI,0FFFh
            ADD   SI,SI
            MOV   AH,BYTE PTR ES:[BX+SI]        { Read card byte }
            MOV   AL,80h                        { Initial bit mask }
            MOV   BX,WORD PTR Addr2
            ADD   BX,WORD PTR Addr3
            LES   SI,DWORD PTR DoublePtr
            MOV   DX,8                          { Do 8 pixels }
            TEST  BYTE PTR OnBits,0FFh
            JZ    @XLoopOff

            { X loop: only display "on" pixels }

@XLoopOn:
            TEST  AH,AL
            JZ    @SkipOn

            MOV   BYTE PTR ES:[BX+SI],CL
            MOV   BYTE PTR ES:[BX+SI+160],CL

            PUSH  ES
            PUSH  BX
            MOV   BX,WORD PTR Addr4
            ADD   BX,WORD PTR Addr5
            LES   DI,DWORD PTR ScreenCollB
            OR    BYTE PTR ES:[BX+DI],AL       { Write the collision bit }
            POP   BX
            POP   ES
@SkipOn:
            SHR   AL,1
            INC   BX
            DEC   DX
            JNZ   @XLoopOn
            JMP   @Bot

            { X loop: only display "off" pixels }

@XLoopOff:
            TEST  AH,AL
            JNZ   @SkipOff

            MOV   BYTE PTR ES:[BX+SI],CL
            MOV   BYTE PTR ES:[BX+SI+160],CL
@SkipOff:
            SHR   AL,1
            INC   BX
            DEC   DX
            JNZ   @XLoopOff
@Bot:
            INC   WORD PTR Addr1
            ADD   WORD PTR Addr3,320
            ADD   WORD PTR Addr5,20
            DEC   WORD PTR Y
            JNZ   @YLoop
          End; { Asm }
        End
        Else
        Begin
          CStack := ColorStack[ColorStackPtr] And $FF;
          CStack := CStack + (CStack Shl 8);
          If Not OnBits Then
          Begin
            For Y := 0 To 3 Do
            Begin
              Asm
                { X loop from 0 to 3 }

                LES   DI,DWORD PTR DoublePtr
                MOV   BX,WORD PTR Addr2
                ADD   BX,WORD PTR Addr3
                MOV   AX,WORD PTR Addr4
                ADD   AX,WORD PTR Addr5
                MOV   CX,WORD PTR Card
                AND   CX,7
                CMP   CX,7
                JNE   @NotClear0To3
                MOV   CX,WORD PTR CStack

                MOV   WORD PTR ES:[BX+DI],CX
                MOV   WORD PTR ES:[BX+DI+160],CX
                MOV   WORD PTR ES:[BX+DI+2],CX
                MOV   WORD PTR ES:[BX+DI+162],CX
                ADD   BX,4
                JMP   @Do4To7
@NotClear0To3:
                MOV   CH,CL
                PUSH  DS
                LDS   SI,DWORD PTR ScreenCollB

                MOV   WORD PTR ES:[BX+DI],CX
                MOV   WORD PTR ES:[BX+DI+160],CX
                MOV   WORD PTR ES:[BX+DI+2],CX
                MOV   WORD PTR ES:[BX+DI+160+2],CX
                PUSH  BX
                MOV   BX,AX
                OR    BYTE PTR [BX+SI],0F0h     { Write the collision bit }
                POP   BX
                ADD   BX,4
                POP   DS
@Do4To7:
                { X loop from 4 to 7 }

                MOV   CX,WORD PTR Card
                SHR   CX,3
                AND   CX,7
                CMP   CX,7
                JNE   @NotClear4To7
                MOV   CX,WORD PTR CStack

                MOV   WORD PTR ES:[BX+DI],CX
                MOV   WORD PTR ES:[BX+DI+160],CX
                MOV   WORD PTR ES:[BX+DI+2],CX
                MOV   WORD PTR ES:[BX+DI+162],CX
                JMP   @GetOut
@NotClear4To7:
                MOV   CH,CL
                PUSH  DS
                LDS   SI,DWORD PTR ScreenCollB

                MOV   WORD PTR ES:[BX+DI],CX
                MOV   WORD PTR ES:[BX+DI+160],CX
                MOV   WORD PTR ES:[BX+DI+2],CX
                MOV   WORD PTR ES:[BX+DI+160+2],CX
                PUSH  BX
                MOV   BX,AX
                OR    BYTE PTR [BX+SI],0Fh     { Write the collision bit }
                POP   BX

                POP   DS
@GetOut:
                ADD   WORD PTR Addr3,320
                ADD   WORD PTR Addr5,20
              End; { Asm }
            End; { For Y }
            For Y := 4 To 7 Do
            Begin
              Asm
                { X loop from 0 to 3 }

                LES   DI,DWORD PTR DoublePtr
                MOV   BX,WORD PTR Addr2
                ADD   BX,WORD PTR Addr3
                MOV   AX,WORD PTR Addr4
                ADD   AX,WORD PTR Addr5
                MOV   CX,WORD PTR Card
                SHR   CX,6
                AND   CX,7
                CMP   CX,7
                JNE   @NotClear0To3
                MOV   CX,WORD PTR CStack

                MOV   WORD PTR ES:[BX+DI],CX
                MOV   WORD PTR ES:[BX+DI+160],CX
                MOV   WORD PTR ES:[BX+DI+2],CX
                MOV   WORD PTR ES:[BX+DI+162],CX
                ADD   BX,4
                JMP   @Do4To7
@NotClear0To3:
                MOV   CH,CL
                PUSH  DS
                LDS   SI,DWORD PTR ScreenCollB

                MOV   WORD PTR ES:[BX+DI],CX
                MOV   WORD PTR ES:[BX+DI+160],CX
                MOV   WORD PTR ES:[BX+DI+2],CX
                MOV   WORD PTR ES:[BX+DI+160+2],CX
                PUSH  BX
                MOV   BX,AX
                OR    BYTE PTR [BX+SI],0F0h     { Write the collision bit }
                POP   BX

                ADD   BX,4
                POP   DS
@Do4To7:
                { X loop from 4 to 7 }

                MOV   CX,WORD PTR Card
                MOV   DX,CX
                SHR   CX,9
                AND   CX,3
                SHR   DX,11
                AND   DX,4
                OR    CX,DX
                CMP   CX,7
                JNE   @NotClear4To7
                MOV   CX,WORD PTR CStack

                MOV   WORD PTR ES:[BX+DI],CX
                MOV   WORD PTR ES:[BX+DI+160],CX
                MOV   WORD PTR ES:[BX+DI+2],CX
                MOV   WORD PTR ES:[BX+DI+162],CX
                JMP   @GetOut
@NotClear4To7:
                MOV   CH,CL
                PUSH  DS
                LDS   SI,DWORD PTR ScreenCollB

                MOV   WORD PTR ES:[BX+DI],CX
                MOV   WORD PTR ES:[BX+DI+160],CX
                MOV   WORD PTR ES:[BX+DI+2],CX
                MOV   WORD PTR ES:[BX+DI+160+2],CX
                PUSH  BX
                MOV   BX,AX
                OR    BYTE PTR [BX+SI],0Fh     { Write the collision bit }
                POP   BX

                POP   DS
@GetOut:
                ADD   WORD PTR Addr3,320
                ADD   WORD PTR Addr5,20
              End; { Asm }
            End; { For Y }
          End;
        End;
        Inc(Addr2,8);
        Inc(Addr4);
      End; { For _X }
    End; { For _Y }
  End; { DrawBacktab }

  Procedure DrawSprites(Priority: Boolean);
  Var
    _X,_Y,X,Y      : Integer;
    Addr           : Word;
    X1             : Integer;
    Addr1          : Word;
    Addr2,Addr3    : Word;

    AddrB,Addr1B   : Word;
    Addr2B,Addr3B  : Word;

    AddrC,Addr1C   : Word;
    Addr3C         : Word;

    I              : Word;
    FCol           : Word;
    SpriteFlags    : LongInt;
    YSize          : Word;
    SpriteMult     : Word;
    SpriteHeight   : Word;
    HasPriority    : Boolean;
    MinX,MinY      : Integer;
    FlagCollisions : Boolean;
    Drawing        : Boolean;
    Card           : Word;

  Begin
    For I := 7 DownTo 0 Do
    Begin
      HasPriority := ((IntvMemPtr[0]^[I + $10] And $2000) = 0);
      Drawing := (HasPriority = Priority);
      Begin
        X     := SpriteX[I];
        Y     := SpriteY[I];
        MinX  := X;
        MinY  := Y;
        If MinX < 0 Then MinX := 0;
        If MinY < 0 Then MinY := 0;
        FCol   := (IntvMemW(I + $10) And $7) + ((IntvMemW(I + $10) Shr 9) And 8);
        Addr   := Word((LongInt(MinY) * 160 + Word(MinX)) And $FFFF);
        AddrB  := Word((LongInt(MinY Shr 1) * 20  + (Word(MinX) Shr 3)) And $FFFF);
        AddrC  := Word((LongInt(MinY Shr 1) * 160 + Word(MinX)) And $FFFF);
        Addr1  := 0;
        Addr1B := 0;
        Addr1C := 0;
        Addr3C := 0;
        SpriteFlags := IntvMemW(I) + (LongInt(IntvMemW(I + 8)) Shl 16);
        If (IntvMemPtr[0]^[I + $0010] And $800) = 0
         Then Addr3 := GROM_Loc + (IntvMemW(I + $10) And $07F8)
         Else Addr3 := GRAM_Loc + (IntvMemW(I + $10) And $03F8);
        SpriteMult := 1;
        If (SpriteFlags And SP_2YSIZE) <> 0 Then SpriteMult := SpriteMult * 2;
        If (SpriteFlags And SP_4YSIZE) <> 0 Then SpriteMult := SpriteMult * 4;
        SpriteHeight := 8 * SpriteMult;
        FlagCollisions := ((SpriteFlags And SP_COLLISION) <> 0);

        If (SpriteFlags And SP_VFLIP) <> 0 Then
        Begin
          If (SpriteFlags And SP_RESOLUTION) <> 0
           Then Inc(Addr3,15)
           Else Inc(Addr3,7);
        End;
        If (SpriteFlags And SP_RESOLUTION) = 0
         Then YSize := SpriteHeight
         Else YSize := SpriteHeight * 2;
        For _Y := 0 To YSize - 1 Do
        Begin
          If (Y + _Y >= 0) And (Y + _Y < 192) Then
          Begin
            Addr2  := 0;
            Addr2B := $80 Shr (MinX And 7);
            Addr3B := 0;
            X1     := X;
            Asm
              MOV   SI,WORD PTR Addr3
              MOV   DI,SI                   { Read the card bits }
              SHR   DI,12
              SHL   DI,2
              LES   BX,DWORD PTR IntvMemPtr[DI]
              MOV   DI,SI
              AND   DI,0FFFh
              ADD   DI,DI
              MOV   AX,WORD PTR ES:[BX+DI]
              MOV   WORD PTR Card,AX
            End; { Asm }
            For _X := 0 To 7 Do
            Begin
              If (X1 + _X >= 0) And (X1 + _X < 160) Then
              Begin
                Asm
                  MOV   SI,WORD PTR Card        { Read the card bits }
                  MOV   CX,WORD PTR _X

                  TEST  WORD PTR SpriteFlags[2],0400h
                  JZ    @HorzFlip

                  MOV   AX,1
                  SHL   AX,CL
                  JMP   @Draw
@HorzFlip:
                  MOV   AX,80h
                  SHR   AX,CL
@Draw:
                  TEST  SI,AX                   { Is the bit on? }
                  JNZ   @OnBit
                  TEST  WORD PTR SpriteFlags,SP_2XSIZE
                  JZ    @NoOnBit
                  INC   WORD PTR Addr2

                  ROR   BYTE PTR Addr2B,1
                  CMP   BYTE PTR Addr2B,80h
                  JNE   @L1
                  INC   BYTE PTR Addr3B
                  JMP   @L1
@OnBit:

                  MOV   DL,BYTE PTR FCol

                  MOV   CX,WORD PTR I           { Sprite number }
                  MOV   AX,0101h
                  SHL   AX,CL

                  MOV   BX,WORD PTR Addr
                  ADD   BX,WORD PTR Addr1
                  ADD   BX,WORD PTR Addr2

                  TEST  WORD PTR SpriteFlags,SP_VISIBLE
                  JZ    @NotVisible

                  TEST  BYTE PTR Drawing,0FFh
                  JZ    @NotVisible

                  LES   SI,DWORD PTR DoublePtr
                  MOV   BYTE PTR ES:[BX+SI],DL  { Write pixel }
@NotVisible:
                  TEST  BYTE PTR FlagCollisions,0FFh
                  JZ    @NoColl

                  PUSH  BX
                  PUSH  DX

                  LES   SI,DWORD PTR ScreenColl
                  MOV   CX,AX

                  MOV   BX,WORD PTR AddrC
                  ADD   BX,WORD PTR Addr1C
                  ADD   BX,WORD PTR Addr2
                  OR    BYTE PTR ES:[BX+SI],CL  { Write the collision bit }
                  MOV   CL,BYTE PTR ES:[BX+SI]  { Read the collision bit }
                  MOV   BX,WORD PTR AddrB
                  ADD   BX,WORD PTR Addr1B
                  ADD   BX,WORD PTR Addr3B
                  LES   SI,DWORD PTR ScreenCollB
                  MOV   DL,BYTE PTR ES:[BX+SI]  { Read the collision bit }
                  LES   BX,DWORD PTR IntvMemPtr[0]
                  MOV   SI,WORD PTR I           { Sprite number }
                  ADD   SI,18h
                  ADD   SI,SI
                  OR    BYTE PTR ES:[BX+SI],CL  { Write the collision bit }
                  TEST  DL,BYTE PTR Addr2B
                  JZ    @NoWrite
                  OR    BYTE PTR ES:[BX+SI+1],1 { Write the collision bit }
@NoWrite:
                  POP   DX
                  POP   BX
@NoColl:
                  INC   WORD PTR Addr2

                  ROR   BYTE PTR Addr2B,1
                  CMP   BYTE PTR Addr2B,80h
                  JNE   @NoRollover
                  INC   BYTE PTR Addr3B
@NoRollover:

                  { See if we have to do another pixel }

                  TEST  WORD PTR SpriteFlags,SP_2XSIZE
                  JZ    @Not2XSize

                  MOV   CX,WORD PTR X1
                  ADD   CX,WORD PTR _X
                  INC   CX
                  CMP   CX,160
                  JAE   @L1

                  TEST  WORD PTR SpriteFlags,SP_VISIBLE
                  JZ    @NotVisible1

                  TEST  BYTE PTR Drawing,0FFh
                  JZ    @NotVisible1

                  LES   SI,DWORD PTR DoublePtr
                  MOV   BYTE PTR ES:[BX+SI+1],DL   { Write pixel }
@NotVisible1:
                  TEST  BYTE PTR FlagCollisions,0FFh
                  JZ    @L1

                  PUSH  BX
                  PUSH  DX
                  LES   SI,DWORD PTR ScreenColl
                  MOV   CX,AX

                  MOV   BX,WORD PTR AddrC
                  ADD   BX,WORD PTR Addr1C
                  ADD   BX,WORD PTR Addr2
                  OR    BYTE PTR ES:[BX+SI+1],CL  { Write the collision bit }
                  MOV   CL,BYTE PTR ES:[BX+SI+1]  { Read the collision bit }
                  MOV   BX,WORD PTR AddrB
                  ADD   BX,WORD PTR Addr1B
                  ADD   BX,WORD PTR Addr3B
                  LES   SI,DWORD PTR ScreenCollB
                  MOV   DL,BYTE PTR ES:[BX+SI]    { Read the collision bit }
                  LES   BX,DWORD PTR IntvMemPtr[0]
                  MOV   SI,WORD PTR I
                  ADD   SI,18h
                  ADD   SI,SI
                  OR    BYTE PTR ES:[BX+SI],CL  { Write the collision bit }
                  TEST  DL,BYTE PTR Addr2B
                  JZ    @NoWrite1
                  OR    BYTE PTR ES:[BX+SI+1],1 { Write the collision bit }
@NoWrite1:
                  POP   DX
                  POP   BX
@L1:
                  INC   WORD PTR X1
@NoOnBit:
                  INC   WORD PTR Addr2

                  ROR   BYTE PTR Addr2B,1
                  CMP   BYTE PTR Addr2B,80h
                  JNE   @Not2XSize
                  INC   BYTE PTR Addr3B
@Not2XSize:
                End; { Asm }
              End
              Else
              Begin
                If FlagCollisions And
                   ((IntvMemPtr[Addr3 Shr 12]^[Addr3 And $FFF] And (1 Shl ((X1 + _X) And 7))) <> 0) Then
                 IntvMemPtr[0]^[I + $18] := IntvMemPtr[0]^[I + $18] Or $200;
              End;
            End; { For _X }
            Inc(Addr1,160);
            Addr3C := Addr3C Xor 1;
            If (Addr3C And 1) = 0 Then
            Begin
              Inc(Addr1C,160);
              Inc(Addr1B,20);
            End;
          End
          Else
          Begin
            If FlagCollisions And (IntvMemPtr[Addr3 Shr 12]^[Addr3 And $FFF] <> 0) Then
             IntvMemPtr[0]^[I + $18] := IntvMemPtr[0]^[I + $18] Or $200;
          End;
          If (_Y And (SpriteMult - 1)) = (SpriteMult - 1) Then
          Begin
            If (SpriteFlags And SP_VFLIP) = 0 Then Inc(Addr3) Else Dec(Addr3);
          End;
        End; { For _Y }
      End;
    End; { For I }

    { Coalesce collision bits }

    For X := 0 To 7 Do
    Begin
      If (IntvMemPtr[0]^[X] And $100) <> 0 Then
      Begin
        I := IntvMemPtr[0]^[X + $18] And ((1 Shl X) Xor $FFFF);
        For Y := 0 To 7 Do
        Begin
          If (Y <> X) And ((I And (1 Shl Y)) <> 0) Then
           IntvMemPtr[0]^[Y + $18] := IntvMemPtr[0]^[Y + $18] Or (1 Shl X);
        End; { For Y }
        IntvMemPtr[0]^[X + $18] := (IntvMemPtr[0]^[X + $18] And $FF00) + (I And $FF);
      End;
    End; { For X }
  End; { DrawSprites }

Begin
  If Config.ExtraLines Then VertOffset := 6 Else VertOffset := 4;
  VertAddrOfs := 320 * VertOffset;
  Inc(Frames);
  HDelay   := IntvMemPtr[0]^[$0030] And 7;
  VDelay   := IntvMemPtr[0]^[$0031] And 7;
  BlockOut := IntvMemPtr[0]^[$0032] And 3;

  FillChar(ScreenColl^,SizeOf(ScreenColl^),#0);   { Clear the collision array }
  FillChar(ScreenCollB^,SizeOf(ScreenCollB^),#0); { Clear the collision array }

  ColorStack[0] := IntvMemPtr[0]^[ColorStackLoc + 0] And $F;
  ColorStack[1] := IntvMemPtr[0]^[ColorStackLoc + 1] And $F;
  ColorStack[2] := IntvMemPtr[0]^[ColorStackLoc + 2] And $F;
  ColorStack[3] := IntvMemPtr[0]^[ColorStackLoc + 3] And $F;
  BorderColor   := IntvMemPtr[0]^[BorderColorLoc] And $F;

  { Clear collision registers }

  IntvMemPtr[0]^[$18] := 0;
  IntvMemPtr[0]^[$19] := 0;
  IntvMemPtr[0]^[$1A] := 0;
  IntvMemPtr[0]^[$1B] := 0;
  IntvMemPtr[0]^[$1C] := 0;
  IntvMemPtr[0]^[$1D] := 0;
  IntvMemPtr[0]^[$1E] := 0;
  IntvMemPtr[0]^[$1F] := 0;

  { Draw BACKTAB OFF pixels }

  DrawBacktab(False);

  { Draw sprites that are behind the background }

  DrawSprites(False);

  { Draw BACKTAB ON pixels }

  DrawBacktab(True);

  { Draw sprites that are on top of the background }

  DrawSprites(True);

  { Block out first column in border color }

  If (BlockOut And 1) <> 0 Then
  Begin
    Color := BorderColor;
    Asm
      MOV   DX,16 * 12
      MOV   AX,0A000h
      MOV   ES,AX
      MOV   DI,WORD PTR VertAddrOfs
      MOV   AL,BYTE PTR Color
      MOV   AH,AL
      MOV   BX,AX
      DB    _32BIT_OPERAND
      SHL   AX,16
      MOV   AX,BX
      CLD
@YLoop:
      DB    _32BIT_OPERAND
      STOSW
      DB    _32BIT_OPERAND
      STOSW
      DB    _32BIT_OPERAND
      STOSW
      DB    _32BIT_OPERAND
      STOSW
      ADD   DI,320 - 16
      DEC   DX
      JNZ   @YLoop
    End; { Asm }
  End;

  { Always block out last pixel column in border color }

  Color := BorderColor;
  Asm
    MOV   DX,16 * 12
    MOV   AX,0A000h
    MOV   ES,AX
    MOV   DI,318
    ADD   DI,WORD PTR VertAddrOfs
    MOV   AL,BYTE PTR Color
    MOV   AH,AL
    CLD
@YLoop:
    MOV   WORD PTR ES:[DI],AX
    ADD   DI,320
    DEC   DX
    JNZ   @YLoop
  End; { Asm }

  { Block out first row and/or vertical delay area in border color }

  Color := BorderColor;
  Asm
    MOV   AX,0A000h
    MOV   ES,AX
    MOV   DI,WORD PTR VertAddrOfs
    MOV   AL,BYTE PTR Color
    MOV   AH,AL
    MOV   BX,AX
    DB    _32BIT_OPERAND
    SHL   AX,16
    MOV   AX,BX
    CLD
    SUB   CX,CX
    TEST  WORD PTR BlockOut,2
    JZ    @L2
    MOV   CX,80 * 16
@L2:
    DB    _32BIT_OPERAND
    PUSH  AX
    MOV   BX,WORD PTR VDelay
    MOV   AX,160
    MUL   BX
    CMP   CX,AX
    JAE   @L3
    MOV   CX,AX
@L3:
    DB    _32BIT_OPERAND
    POP   AX
    TEST  CX,CX
    JZ    @L1
    DB    _32BIT_OPERAND
    REP   STOSW
@L1:
  End; { Asm }

  { Always block out top of screen in border color }

  Color := BorderColor;
  Asm
    MOV   AX,0A000h
    MOV   ES,AX
    SUB   DI,DI
    MOV   AL,BYTE PTR Color
    MOV   AH,AL
    MOV   BX,AX
    DB    _32BIT_OPERAND
    SHL   AX,16
    MOV   AX,BX
    CLD
    MOV   CX,80 * 4
    CMP   WORD PTR VertOffset,6
    JNE   @L1
    MOV   CX,80 * 6
@L1:
    DB    _32BIT_OPERAND
    REP   STOSW
  End; { Asm }

  { Always block out bottom of screen in border color }

  Color := BorderColor;
  Asm
    MOV   AX,0A000h
    MOV   ES,AX
    MOV   DI,320 * 96 * 2
    ADD   DI,WORD PTR VertAddrOfs
    MOV   AL,BYTE PTR Color
    MOV   AH,AL
    MOV   BX,AX
    DB    _32BIT_OPERAND
    SHL   AX,16
    MOV   AX,BX
    CLD
    MOV   CX,80 * 4
    CMP   WORD PTR VertOffset,6
    JNE   @L1
    MOV   CX,80 * 6
@L1:
    DB    _32BIT_OPERAND
    REP   STOSW
  End; { Asm }

  { Copy graphics page }

  I := VDelay * 320 + HDelay;
  If (BlockOut And 1) <> 0 Then
  Begin
    Asm
      CLD
      MOV    DX,192
      SUB    BX,BX
      TEST   WORD PTR BlockOut,2
      JZ     @L3
      MOV    DX,192-16
      MOV    BX,160*16
@L3:
      MOV    AX,0A000h
      MOV    ES,AX
      MOV    DI,WORD PTR VertAddrOfs
      ADD    DI,BX
      ADD    DI,BX
      ADD    DI,16
      PUSH   DS
      LDS    SI,DWORD PTR DoublePtr
      ADD    SI,BX
      ADD    SI,8
      SUB    SI,WORD PTR I
@L2:
      MOV    CX,159-8
@L1:
      LODSB
      MOV    AH,AL
      STOSW
      LOOP   @L1
      ADD    DI,2+16
      ADD    SI,1+8
      DEC    DX
      JNZ    @L2
      POP    DS
    End; { Asm }
  End
  Else
  Begin
    Asm
      CLD
      MOV    DX,192
      SUB    BX,BX
      TEST   WORD PTR BlockOut,2
      JZ     @L3
      MOV    DX,192-16
      MOV    BX,160*16
@L3:
      MOV    AX,0A000h
      MOV    ES,AX
      MOV    DI,WORD PTR VertAddrOfs
      ADD    DI,BX
      ADD    DI,BX
      PUSH   DS
      LDS    SI,DWORD PTR DoublePtr
      ADD    SI,BX
      SUB    SI,WORD PTR I
@L2:
      MOV    CX,159
@L1:
      LODSB
      MOV    AH,AL
      STOSW
      LOOP   @L1
      ADD    DI,2
      INC    SI
      DEC    DX
      JNZ    @L2
      POP    DS
    End; { Asm }
  End;
{
  WriteOut(0,0 ,'VDelay=' + IntToStr(VDelay),15);
  WriteOut(0,8 ,'HDelay=' + IntToStr(HDelay),15);
  WriteOut(0,16,'BlockOut=' + IntToStr(BlockOut),15);
}
End; { FormPaint }
{$F-}

Procedure Emulate;
Var
  I,J       : LongInt;
  ECSEnable : Word;
  OldCard   : Word;
  CardChange : Word;

  Procedure Perform_Interrupt(Addr: Word);
  Begin
    IntvMemPtr[Regs[6] Shr 12]^[Regs[6] And $FFF] := Regs[7];
    Inc(Regs[6]);
    Regs[7] := Addr;
  End; { Perform_Interrupt }

Label EmulateLoop,
      _HLT,_SDBD,_EIS,_DIS,_Jxxx,_TCI,_CLRC,_SETC,_INCR,_DECR,_COMR,_NEGR,
      _ADCR,_GSWD,_NOP,_SIN,_RSWD,_SWAP,_SLL,_RLC,_SLLC,_SLR,_SAR,_RRC,
      _SARC,_MOVR,_ADDR,_SUBR,_CMPR,_ANDR,_XORR,_Bxxxx,_MVO,_MVOimp,
      _MVI,_MVIimp,_ADD,_ADDimp,_SUB,_SUBimp,_CMP,_CMPimp,_AND,_ANDimp,
      _XOR,_XORimp;

Begin
  EBCA      := 0;
  EBCI      := False;
  InsCount  := 0;
  SlowCount := 0;

  { Fill in clock cycle array }

  Cycles[0] := 4;          { HLT }
  Cycles[1] := 4;          { SDBD }
  Cycles[2] := 4;          { EIS }
  Cycles[3] := 4;          { DIS }
  Cycles[4] := 12;         { J/JD/JE/JSR/JSRD/JSRE }
  Cycles[5] := 4;          { TCI }
  Cycles[6] := 4;          { CLRC }
  Cycles[7] := 4;          { SETC }
  For I := 8 To $3F Do     { INCR/DECR/COMR/NEGR/ADCR/GSWD/RSWD }
   Cycles[I] := 6;
  For I := $40 To $7F Do   { SWAP/SLL/RLC/SLLC/SLR/SAR/RRC/SARC }
  Begin
    If (I And 4) = 0
     Then Cycles[I] := 6
     Else Cycles[I] := 8;
  End; { For I }
  For I := $80 To $1FF Do  { ADDR/SUBR/CMPR/ANDR/XORR }
  Begin
    If (I And 7) = 7
     Then Cycles[I] := 7
     Else Cycles[I] := 6;
  End; { For I }
  For I := $200 To $23F Do { Bcond/BEXT }
   Cycles[I] := 7;
  For I := $240 To $27F Do { MVO/MVO@ }
  Begin
    If (I And $38) = 0
     Then Cycles[I] := 11
     Else Cycles[I] := 9;
  End; { For I }
  For I := $280 To $3FF Do { MVI/MVI@/ADD/ADD@/SUB/SUB@/CMP/CMP@/AND/AND@/XOR/XOR@ }
  Begin
    If (I And $38) = 0
     Then Cycles[I] := 10
     Else
     Begin
       If (I And 7) = 7
        Then Cycles[I] := 8
        Else Cycles[I] := 11;
     End;
  End; { For I }

  Asm
    MOV   WORD PTR Locations[0000h * 2],OFFSET _HLT
    MOV   WORD PTR Locations[0001h * 2],OFFSET _SDBD
    MOV   WORD PTR Locations[0002h * 2],OFFSET _EIS
    MOV   WORD PTR Locations[0003h * 2],OFFSET _DIS
    MOV   WORD PTR Locations[0004h * 2],OFFSET _Jxxx
    MOV   WORD PTR Locations[0005h * 2],OFFSET _TCI
    MOV   WORD PTR Locations[0006h * 2],OFFSET _CLRC
    MOV   WORD PTR Locations[0007h * 2],OFFSET _SETC
    MOV   WORD PTR Locations[0008h * 2],OFFSET _INCR  { Must be copied }
    MOV   WORD PTR Locations[0010h * 2],OFFSET _DECR
    MOV   WORD PTR Locations[0018h * 2],OFFSET _COMR
    MOV   WORD PTR Locations[0020h * 2],OFFSET _NEGR
    MOV   WORD PTR Locations[0028h * 2],OFFSET _ADCR
    MOV   WORD PTR Locations[0030h * 2],OFFSET _GSWD
    MOV   WORD PTR Locations[0031h * 2],OFFSET _GSWD
    MOV   WORD PTR Locations[0032h * 2],OFFSET _GSWD
    MOV   WORD PTR Locations[0033h * 2],OFFSET _GSWD
    MOV   WORD PTR Locations[0034h * 2],OFFSET _NOP
    MOV   WORD PTR Locations[0035h * 2],OFFSET _NOP
    MOV   WORD PTR Locations[0036h * 2],OFFSET _SIN
    MOV   WORD PTR Locations[0037h * 2],OFFSET _SIN
    MOV   WORD PTR Locations[0038h * 2],OFFSET _RSWD
    MOV   WORD PTR Locations[0040h * 2],OFFSET _SWAP
    MOV   WORD PTR Locations[0048h * 2],OFFSET _SLL
    MOV   WORD PTR Locations[0050h * 2],OFFSET _RLC
    MOV   WORD PTR Locations[0058h * 2],OFFSET _SLLC
    MOV   WORD PTR Locations[0060h * 2],OFFSET _SLR
    MOV   WORD PTR Locations[0068h * 2],OFFSET _SAR
    MOV   WORD PTR Locations[0070h * 2],OFFSET _RRC
    MOV   WORD PTR Locations[0078h * 2],OFFSET _SARC
    MOV   WORD PTR Locations[0080h * 2],OFFSET _MOVR
    MOV   WORD PTR Locations[00C0h * 2],OFFSET _ADDR
    MOV   WORD PTR Locations[0100h * 2],OFFSET _SUBR
    MOV   WORD PTR Locations[0140h * 2],OFFSET _CMPR
    MOV   WORD PTR Locations[0180h * 2],OFFSET _ANDR
    MOV   WORD PTR Locations[01C0h * 2],OFFSET _XORR
    MOV   WORD PTR Locations[0200h * 2],OFFSET _Bxxxx
    MOV   WORD PTR Locations[0240h * 2],OFFSET _MVO
    MOV   WORD PTR Locations[0248h * 2],OFFSET _MVOimp
    MOV   WORD PTR Locations[0280h * 2],OFFSET _MVI
    MOV   WORD PTR Locations[0288h * 2],OFFSET _MVIimp
    MOV   WORD PTR Locations[02C0h * 2],OFFSET _ADD
    MOV   WORD PTR Locations[02C8h * 2],OFFSET _ADDimp
    MOV   WORD PTR Locations[0300h * 2],OFFSET _SUB
    MOV   WORD PTR Locations[0308h * 2],OFFSET _SUBimp
    MOV   WORD PTR Locations[0340h * 2],OFFSET _CMP
    MOV   WORD PTR Locations[0348h * 2],OFFSET _CMPimp
    MOV   WORD PTR Locations[0380h * 2],OFFSET _AND
    MOV   WORD PTR Locations[0388h * 2],OFFSET _ANDimp
    MOV   WORD PTR Locations[03C0h * 2],OFFSET _XOR
    MOV   WORD PTR Locations[03C8h * 2],OFFSET _XORimp
  End; { Asm }
  For I := 1 To 7 Do
  Begin
    Locations[I + $08]  := Locations[8];
    Locations[I + $10]  := Locations[$10];
    Locations[I + $18]  := Locations[$18];
    Locations[I + $20]  := Locations[$20];
    Locations[I + $28]  := Locations[$28];
    Locations[I + $38]  := Locations[$38];
    Locations[I + $40]  := Locations[$40];
    Locations[I + $48]  := Locations[$48];
    Locations[I + $50]  := Locations[$50];
    Locations[I + $58]  := Locations[$58];
    Locations[I + $60]  := Locations[$60];
    Locations[I + $68]  := Locations[$68];
    Locations[I + $70]  := Locations[$70];
    Locations[I + $78]  := Locations[$78];
    Locations[I + $240] := Locations[$240];
    Locations[I + $280] := Locations[$280];
    Locations[I + $2C0] := Locations[$2C0];
    Locations[I + $300] := Locations[$300];
    Locations[I + $340] := Locations[$340];
    Locations[I + $380] := Locations[$380];
    Locations[I + $3C0] := Locations[$3C0];
  End; { For I }
  For I := 1 To 63 Do
  Begin
    Locations[I + $80]  := Locations[$80];
    Locations[I + $C0]  := Locations[$C0];
    Locations[I + $100] := Locations[$100];
    Locations[I + $140] := Locations[$140];
    Locations[I + $180] := Locations[$180];
    Locations[I + $1C0] := Locations[$1C0];
    Locations[I + $200] := Locations[$200];
  End; { For I }
  For I := 1 To 55 Do
  Begin
    Locations[I + $248] := Locations[$248];
    Locations[I + $288] := Locations[$288];
    Locations[I + $2C8] := Locations[$2C8];
    Locations[I + $308] := Locations[$308];
    Locations[I + $348] := Locations[$348];
    Locations[I + $388] := Locations[$388];
    Locations[I + $3C8] := Locations[$3C8];
  End; { For I }
  If LogOutput Then
  Begin
    Assign(LogFile,CurrentDir + '\' + 'INTVEMU.LOG');
    ReWrite(LogFile);
  End;
  IntPending := False;

  I := GRAM_LOC + $29 * 8 + 4;
  I := IntvMemPtr[I Shr 12]^[I And $FFF];
  OldCard := I;
  CardChange := 0;

EmulateLoop:

  { Do I/O emulation here }

{  If LogOutput Then WriteLn(LogFile,HexWord(Regs[7]) + '---' + Disassemble(@IntvMem,Regs[7]));}



(*
  If LogOutput Then
   WriteLn(LogFile,HexWord(Regs[0]),' ',
                 HexWord(Regs[1]),' ',
                 HexWord(Regs[2]),' ',
                 HexWord(Regs[3]),' ',
                 HexWord(Regs[4]),' ',
                 HexWord(Regs[5]),' ',
                 HexWord(Regs[6]),'-',
                 HexWord(Regs[7]),'--',
                 HexWord(IntvMemW($0100)),' ',
                 HexWord(IntvMemW($0101)),' ',
                 Disassemble(PD1600Mem(IntvMemPtr[Regs[7] Shr 12]),Regs[7] And $FFF));
*)



{
  For I := $2F0 To $2FF Do Write(LogFile,HexWord(IntvMem[I]),' ');
  Write(LogFile,' [035F]=' + HexWord(IntvMem[$035F]));
  WriteLn(LogFile);
  If IntvMem[Regs[7]] > $3FF Then CloseFile(LogFile);
}

{  WriteLn(LogFile,HexWord(Regs[7]));}



{  If (InsCount And $FFF) = 0 Then EventHandler;}


(*
  If ((InsCount And InterruptFlag) = 0) And
     (Tracing <> 1)                     And
     Interrupts                         Then
  Begin
    If Interruptable And Not DoubleByte
     Then
     Begin
       Perform_Interrupt($1004);
       Form1.FormPaint(Form1);
{       If LogOutput Then WriteLn(LogFile,'Repainting');}
     End
     Else Dec(InsCount);
  End;
*)



(*
  If InsCount >= InterruptCycles Then
  Begin
    EventHandler;
    If Config.FrameRate <> 0 Then SlowDown;
    If Interrupts Then
    Begin
      If Interruptable And Not DoubleByte
       Then
       Begin
         Perform_Interrupt($1004);
         Form1.FormPaint(Form1);
       End;
{       Else Dec(InsCount);}
    End;
    InsCount := 0;
  End;
*)

{  WriteOut(1,1,HexWord(Regs[7]),15);}

  If InsCount >= InterruptCycles / 100 Then
  Begin
    PollIntv2PC;
    If (Config.FrameRate <> 0) And
       (ECSKey Or Not (Importing Or ECSSave Or ECSLoad Or Not DoSlowDown)) Then SlowDown(10);
    InsCount := InsCount - Trunc(InterruptCycles / 100);
    Inc(SlowCount);
  End;

{  If InsCount >= InterruptCycles Then}
  If SlowCount >= 100 Then
  Begin
    EventHandler;
{    If Config.FrameRate <> 0 Then SlowDown(1000);}
    IntPending := True;
{    InsCount   := InsCount - Trunc(InterruptCycles);}
    SlowCount := 0;
  End;
  If IntPending Then
  Begin
    If Interrupts > 2 Then
    Begin
      If Not DoubleByte
       Then
       Begin
         Perform_Interrupt($1004);
         FormPaint;
         IntPending := False;

{
  If LogOutput Then
  Begin
   WriteLn(LogFile,'Interrupt');
   WriteLn(LogFile,HexWord(Regs[0]),' ',
                 HexWord(Regs[1]),' ',
                 HexWord(Regs[2]),' ',
                 HexWord(Regs[3]),' ',
                 HexWord(Regs[4]),' ',
                 HexWord(Regs[5]),' ',
                 HexWord(Regs[6]),'-',
                 HexWord(Regs[7]),'--',
                 HexWord(IntvMemW($0100)),' ',
                 HexWord(IntvMemW($0101)),' ',
                 Disassemble(PD1600Mem(IntvMemPtr[Regs[7] Shr 12]),Regs[7] And $FFF));
  End;
}
       End;
    End;
  End;
{
  I := GRAM_LOC + $29 * 8 + 4;
  I := IntvMemPtr[I Shr 12]^[I And $FFF];
  If I <> OldCard Then
  Begin
    If CardChange > 5 Then
    Begin
      Emulating  := False;
      NewList    := True;
      FormPaint(Self);

      If LogOutput Then Close(LogFile);

      Exit;
    End
    Else Inc(CardChange);
    OldCard := I;
  End;
}
{
  If (Regs[7] = Breakpoint) And (Tracing <> 1) And Breaking Then
  Begin
    Emulating  := False;
    NewList    := True;
    FormPaint(Self);

    If LogOutput Then Close(LogFile);

    Exit;
  End;
}
{  Inc(InsCount);}

  ECSEnable := IntvMemPtr[0]^[$01F8];
  If (ECSEnable And $40) = 0 Then IntvMemPtr[0]^[$01FE] := RightController;
  If (ECSEnable And $80) = 0 Then IntvMemPtr[0]^[$01FF] := LeftController;
  If Cart = CartECS Then
  Begin
    ECSEnable := IntvMemPtr[0]^[$00F8];
    If (ECSEnable And $40) = 0 Then IntvMemPtr[0]^[$00FE] := ECSRightController Or $FF00;
    If (ECSEnable And $80) = 0 Then IntvMemPtr[0]^[$00FF] := ECSLeftController Or $FF00;
  End;

  { Stop if we have reached a debugger breakpoint }

  If Debugger Then
  Begin
    If (Trace = 0) And (DebugAddr = Regs[7]) Then Emulating := False;
    If Trace >= 2 Then
    Begin
      Trace     := 0;
      Emulating := False;
    End;
    If (BreakExpColl <> Nil) And
       Evaluate(BreakExpColl,IntvMemPtr,Regs,StatusWord,SpriteX,SpriteY,
                ReadMem,WriteMem,RWMemLoc,ExpError)
     Then Emulating := False;
    If Trace > 0 Then Inc(Trace);
  End;
  ReadMem  := False;
  WriteMem := False;
  RWMemLoc := 0;

  { Stop if we have to }

  If Not Emulating Then
  Begin

    If LogOutput Then Close(LogFile);
    If AVIFile.Opened Then AVIFile.Close;
    Exit;
  End;

  Interrupts := Interrupts Or 1;

  Asm
    MOV   DI,WORD PTR Regs[7 * 2]     { Regs[7] is the PC }
    MOV   SI,DI
    SHR   SI,12
    SHL   SI,2
    LES   BX,DWORD PTR IntvMemPtr[SI]
    MOV   SI,DI
    AND   SI,0FFFh
    ADD   SI,SI
    MOV   AX,WORD PTR ES:[BX+SI]      { Save the opcode }
    MOV   SI,AX                       { Quadruple it to get the destination }
    AND   SI,03FFh
    SUB   BX,BX
    MOV   BL,BYTE PTR Cycles[SI]      { Get the number of cycles }
    ADD   WORD PTR InsCount,BX
    ADD   SI,SI

    MOV   BX,WORD PTR Locations[SI]   { Get the destination }
{    ADD   SI,SI}
    JMP   BX                          { Jump to it }
  End; { Asm }

_HLT:                                  { HLT   0000000000 }

  Asm
    INC   WORD PTR Regs[7 * 2]
    MOV   BYTE PTR DoubleByte,0
    JMP   EmulateLoop
  End; { Asm }

_SDBD:                                 { SDBD  0000000001 }

  Asm
    MOV   BYTE PTR DoubleByte,1
    INC   WORD PTR Regs[7 * 2]
    AND   BYTE PTR Interrupts,0FEh
    JMP   EmulateLoop
  End; { Asm }

_EIS:                                  { EIS   0000000010 }

  Asm
    MOV   BYTE PTR Interrupts,2
    MOV   BYTE PTR DoubleByte,0
    INC   WORD PTR Regs[7 * 2]
    JMP   EmulateLoop
  End; { Asm }

_DIS:                                  { DIS   0000000011 }

  Asm
    MOV   BYTE PTR Interrupts,0
    MOV   BYTE PTR DoubleByte,0
    INC   WORD PTR Regs[7 * 2]
    JMP   EmulateLoop
  End; { Asm }

_Jxxx:                                 { Jxxx  0000000100 }

  Asm
    MOV   SI,DI
    INC   SI
    SHR   SI,12
    SHL   SI,2
    LES   BX,DWORD PTR IntvMemPtr[SI]
    MOV   SI,DI
    INC   SI
    AND   SI,0FFFh
    ADD   SI,SI
    MOV   AX,WORD PTR ES:[BX+SI]
    MOV   BX,AX
    AND   BX,3
    CMP   BX,1
    JNZ   @L1
    MOV   BYTE PTR Interrupts,2
@L1:
    CMP   BX,2
    JNZ   @L2
    MOV   BYTE PTR Interrupts,0
@L2:
    MOV   BX,AX
    AND   BX,300h
    SHR   BX,7
    OR    BX,8
    MOV   CX,WORD PTR Regs[7 * 2]
    ADD   CX,3
    MOV   WORD PTR Regs[BX],CX
    AND   AX,0FCh

    PUSH  AX
    MOV   SI,DI
    ADD   SI,2
    SHR   SI,12
    SHL   SI,2
    LES   BX,DWORD PTR IntvMemPtr[SI]
    MOV   SI,DI
    ADD   SI,2
    AND   SI,0FFFh
    ADD   SI,SI
    MOV   AX,WORD PTR ES:[BX+SI]
    MOV   BX,AX
    POP   AX

    AND   BX,3FFh
    SHL   AX,8
    OR    AX,BX
    MOV   WORD PTR Regs[7 * 2],AX
    MOV   BYTE PTR DoubleByte,0
    JMP   EmulateLoop
  End; { Asm }

_TCI:                                  { TCI   0000000101 }

  Asm
    MOV   BYTE PTR DoubleByte,0
    MOV   BYTE PTR Interrupts,2
    DEC   WORD PTR Regs[6 * 2]
    MOV   DI,WORD PTR Regs[6 * 2]

    MOV   SI,DI
    SHR   SI,12
    SHL   SI,2
    LES   BX,DWORD PTR IntvMemPtr[SI]
    MOV   SI,DI
    AND   SI,0FFFh
    ADD   SI,SI
    MOV   AX,WORD PTR ES:[BX+SI]
    MOV   DI,AX

    MOV   WORD PTR Regs[7 * 2],DI
    JMP   EmulateLoop
  End; { Asm }

_CLRC:                                 { CLRC  0000000110 }

  Asm
    MOV   BYTE PTR DoubleByte,0
    AND   WORD PTR StatusWord,0Eh
    INC   WORD PTR Regs[7 * 2]
    AND   BYTE PTR Interrupts,0FEh
    JMP   EmulateLoop
  End; { Asm }

_SETC:                                 { SETC  0000000111 }

  Asm
    MOV   BYTE PTR DoubleByte,0
    OR    WORD PTR StatusWord,1
    INC   WORD PTR Regs[7 * 2]
    AND   BYTE PTR Interrupts,0FEh
    JMP   EmulateLoop
  End; { Asm }

_INCR:                                 { INCR  0000001ddd }

  Asm
    INC   WORD PTR Regs[7 * 2]
    MOV   BYTE PTR DoubleByte,0
    MOV   BX,AX
    AND   BX,7
    ADD   BX,BX
    INC   WORD PTR Regs[BX]
    MOV   DX,WORD PTR Regs[BX]
    OR    DX,DX
    LAHF
    SHR   AX,12
    AND   AX,0Ch
    AND   WORD PTR StatusWord,3
    OR    WORD PTR StatusWord,AX
    JMP   EmulateLoop
  End; { Asm }

_DECR:                                 { DECR  0000010ddd }

  Asm
    INC   WORD PTR Regs[7 * 2]
    MOV   BYTE PTR DoubleByte,0
    MOV   BX,AX
    AND   BX,7
    ADD   BX,BX
    DEC   WORD PTR Regs[BX]
    MOV   DX,WORD PTR Regs[BX]
    OR    DX,DX
    LAHF
    SHR   AX,12
    AND   AX,0Ch
    AND   WORD PTR StatusWord,3
    OR    WORD PTR StatusWord,AX
    JMP   EmulateLoop
  End; { Asm }

_COMR:                                 { COMR  0000011ddd }

  Asm
    INC   WORD PTR Regs[7 * 2]
    MOV   BYTE PTR DoubleByte,0
    MOV   BX,AX
    AND   BX,7
    ADD   BX,BX
    NOT   WORD PTR Regs[BX]
    MOV   DX,WORD PTR Regs[BX]
    OR    DX,DX
    LAHF
    SHR   AX,12
    AND   AX,0Ch
    AND   WORD PTR StatusWord,3
    OR    WORD PTR StatusWord,AX
    JMP   EmulateLoop
  End; { Asm }

_NEGR:                                 { NEGR  0000100ddd }

  Asm
    INC   WORD PTR Regs[7 * 2]
    MOV   BYTE PTR DoubleByte,0
    MOV   BX,AX
    AND   BX,7
    ADD   BX,BX
    NEG   WORD PTR Regs[BX]
    MOV   AL,2
    LAHF
    JO    @L1
    XOR   AL,AL
@L1:
    AND   AH,0C1h
    OR    AL,AH
    SHR   AH,4
    OR    AL,AH
    AND   AX,0Fh
    MOV   WORD PTR StatusWord,AX
    JMP   EmulateLoop
  End; { Asm }

_ADCR:                                 { ADCR  0000101ddd }

  Asm
    INC   WORD PTR Regs[7 * 2]
    MOV   BYTE PTR DoubleByte,0
    MOV   BX,AX
    AND   BX,7
    ADD   BX,BX
    MOV   AX,WORD PTR StatusWord
    AND   AX,1
    ADD   WORD PTR Regs[BX],AX
    MOV   AL,2
    LAHF
    JO    @L1
    XOR   AL,AL
@L1:
    AND   AH,0C1h
    OR    AL,AH
    SHR   AH,4
    OR    AL,AH
    AND   AX,0Fh
    MOV   WORD PTR StatusWord,AX
    JMP   EmulateLoop
  End; { Asm }

_GSWD:                                 { GSWD  00001100rr }

  Asm
    MOV   BYTE PTR DoubleByte,0
    MOV   BX,AX
    AND   BX,3
    ADD   BX,BX
    MOV   AX,WORD PTR StatusWord
    MOV   AH,AL
    AND   AX,0F0Fh
    SHL   AX,4
    MOV   WORD PTR Regs[BX],AX
    INC   WORD PTR Regs[7 * 2]
    AND   BYTE PTR Interrupts,0FEh
    JMP   EmulateLoop
  End; { Asm }

_NOP:                                  { NOP   000011010m }

  Asm
    MOV   BYTE PTR DoubleByte,0
    INC   WORD PTR Regs[7 * 2]
    JMP   EmulateLoop
  End; { Asm }

_SIN:                                  { SIN   000011011m }

  Asm
    MOV   BYTE PTR DoubleByte,0
    INC   WORD PTR Regs[7 * 2]
    JMP   EmulateLoop
  End; { Asm }

_RSWD:                                 { RSWD  0000111sss }

  Asm
    MOV   BYTE PTR DoubleByte,0
    MOV   BX,AX
    AND   BX,7
    ADD   BX,BX
    MOV   AX,WORD PTR Regs[BX]
    SHR   AX,4
    AND   AX,0Fh
    MOV   WORD PTR StatusWord,AX
    INC   WORD PTR Regs[7 * 2]
    AND   BYTE PTR Interrupts,0FEh
    JMP   EmulateLoop
  End; { Asm }

_SWAP:                                 { SWAP  0001000mrr }

  Asm
    INC   WORD PTR Regs[7 * 2]
    MOV   BYTE PTR DoubleByte,0
    MOV   BX,AX
    AND   BX,3
    ADD   BX,BX
    MOV   CX,WORD PTR Regs[BX]

    TEST  AX,4
    JNZ   @L3
    MOV   DX,CX
    XCHG  CH,CL
    MOV   WORD PTR Regs[BX],CX
    JMP   @L1
@L3:
    MOV   CH,CL
    MOV   WORD PTR Regs[BX],CX
    MOV   DX,CX

@L1:
    OR    DX,DX
    LAHF
    SHR   AX,12
    AND   AX,0Ch
    AND   WORD PTR StatusWord,3
    OR    WORD PTR StatusWord,AX
    AND   BYTE PTR Interrupts,0FEh
    JMP   EmulateLoop
  End; { Asm }

_SLL:                                  { SLL   0001001mrr }

  Asm
    INC   WORD PTR Regs[7 * 2]
    MOV   BYTE PTR DoubleByte,0
    MOV   CL,1
    TEST  AL,4
    JZ    @L2
    INC   CL
@L2:
    MOV   BX,AX
    AND   BX,3
    ADD   BX,BX
    SHL   WORD PTR Regs[BX],CL
    MOV   DX,WORD PTR Regs[BX]
    OR    DX,DX
    LAHF
    SHR   AX,12
    AND   AX,0Ch
    AND   WORD PTR StatusWord,3
    OR    WORD PTR StatusWord,AX
    AND   BYTE PTR Interrupts,0FEh
    JMP   EmulateLoop
  End; { Asm }

_RLC:                                  { RLC   0001010mrr }

  Asm
    AND   BYTE PTR Interrupts,0FEh
    INC   WORD PTR Regs[7 * 2]
    MOV   BYTE PTR DoubleByte,0
    MOV   BX,AX
    AND   BX,3
    ADD   BX,BX
    MOV   DX,WORD PTR Regs[BX]
    TEST  AX,4
    JNZ   @TwoBits
    MOV   AX,WORD PTR StatusWord
    AND   AX,0Fh
    SHR   AL,1
    ADC   DX,DX
    LAHF
    MOV   WORD PTR Regs[BX],DX
    ADC   AL,AL
    SHR   AH,4
    AND   AX,0C03h
    OR    AL,AH
    SUB   AH,AH
    MOV   WORD PTR StatusWord,AX
    JMP   EmulateLoop
@TwoBits:
    MOV   AX,WORD PTR StatusWord
    AND   AX,0Fh
    SHR   AX,1
    ADC   DX,DX
    RCR   AX,1
    ADC   DX,DX
    RCR   AX,0Fh
    MOV   WORD PTR Regs[BX],DX
    OR    DX,DX
    LAHF
    SHR   AH,4
    AND   AX,0C03h
    OR    AL,AH
    SUB   AH,AH
    MOV   WORD PTR StatusWord,AX
    JMP   EmulateLoop
  End; { Asm }

_SLLC:                                 { SLLC  0001011mrr }

  Asm
    AND   BYTE PTR Interrupts,0FEh
    INC   WORD PTR Regs[7 * 2]
    MOV   BYTE PTR DoubleByte,0
    MOV   BX,AX
    AND   BX,3
    ADD   BX,BX
    TEST  AX,4
    JNZ   @TwoBits
    MOV   CX,WORD PTR StatusWord
    AND   CX,2
    SHL   WORD PTR Regs[BX],1
    LAHF
    ADC   CX,0
    SHR   AH,4
    AND   AH,0Ch
    OR    CL,AH
    MOV   WORD PTR StatusWord,CX
    JMP   EmulateLoop
@TwoBits:
    XOR   CX,CX
    MOV   DX,WORD PTR Regs[BX]
    ADD   DX,DX
    ADC   CH,CH
    ADD   DX,DX
    ADC   CL,CL
    MOV   WORD PTR Regs[BX],DX
    OR    DX,DX
    LAHF
    ADD   CL,CL
    OR    CL,CH
    SHR   AH,4
    AND   AH,0Ch
    OR    CL,AH
    SUB   CH,CH
    MOV   WORD PTR StatusWord,CX
    JMP   EmulateLoop
  End; { Asm }

_SLR:                                  { SLR   0001100mrr }

  Asm
    INC   WORD PTR Regs[7 * 2]
    MOV   BYTE PTR DoubleByte,0
    MOV   BX,AX
    AND   BX,3
    ADD   BX,BX
    MOV   DX,WORD PTR Regs[BX]
    MOV   CL,1
    TEST  AX,4
    JZ    @L1
    INC   CL
@L1:
    SHR   DX,CL
    MOV   WORD PTR Regs[BX],DX
    XCHG  DL,DH
    OR    DX,DX
    LAHF
    MOV   AL,BYTE PTR StatusWord
    AND   AX,0C003h
    SHR   AH,4
    OR    AL,AH
    SUB   AH,AH
    MOV   WORD PTR StatusWord,AX
    AND   BYTE PTR Interrupts,0FEh
    JMP   EmulateLoop
  End; { Asm }

_SAR:                                  { SAR   0001101mrr }

  Asm
    INC   WORD PTR Regs[7 * 2]
    MOV   BYTE PTR DoubleByte,0
    MOV   BX,AX
    AND   BX,3
    ADD   BX,BX
    MOV   DX,WORD PTR Regs[BX]
    MOV   CL,1
    TEST  AX,4
    JZ    @L1
    INC   CL
@L1:
    SAR   DX,CL
    MOV   WORD PTR Regs[BX],DX
    XCHG  DL,DH
    OR    DX,DX
    LAHF
    MOV   AL,BYTE PTR StatusWord
    AND   AX,0C003h
    SHR   AH,4
    OR    AL,AH
    SUB   AH,AH
    MOV   WORD PTR StatusWord,AX
    AND   BYTE PTR Interrupts,0FEh
    JMP   EmulateLoop
  End; { Asm }

_RRC:                                  { RRC   0001110mrr }

  Asm
    AND   BYTE PTR Interrupts,0FEh
    INC   WORD PTR Regs[7 * 2]
    MOV   BYTE PTR DoubleByte,0
    MOV   BX,AX
    AND   BX,3
    ADD   BX,BX
    MOV   DX,WORD PTR Regs[BX]
    TEST  AX,4
    JNZ   @TwoBits
    MOV   AX,WORD PTR StatusWord
    SHR   AX,1
    RCR   DX,1
    MOV   WORD PTR Regs[BX],DX
    ADC   AX,AX
    XCHG  DL,DH
    OR    DX,DX
    LAHF
    SHR   AH,4
    AND   AX,0C03h
    OR    AL,AH
    SUB   AH,AH
    MOV   WORD PTR StatusWord,AX
    JMP   EmulateLoop
@TwoBits:
    MOV   CX,WORD PTR StatusWord
    SHL   CL,6
    MOV   AX,DX
    SHR   DX,2
    OR    DH,CL
    MOV   WORD PTR Regs[BX],DX
    XCHG  DL,DH
    OR    DX,DX
    LAHF
    SHR   AH,4
    AND   AX,0C03h
    OR    AL,AH
    SUB   AH,AH
    MOV   WORD PTR StatusWord,AX
    JMP   EmulateLoop
  End; { Asm }

_SARC:                                 { SARC  0001111mrr }

  Asm
    AND   BYTE PTR Interrupts,0FEh
    INC   WORD PTR Regs[7 * 2]
    MOV   BYTE PTR DoubleByte,0
    MOV   BX,AX
    AND   BX,3
    ADD   BX,BX
    MOV   DX,WORD PTR Regs[BX]
    TEST  AX,4
    JNZ   @TwoBits
    MOV   CX,WORD PTR StatusWord
    AND   CX,2
    SAR   DX,1
    MOV   WORD PTR Regs[BX],DX
    ADC   CX,0
    XCHG  DL,DH
    OR    DX,DX
    LAHF
    SHR   AH,4
    AND   AH,0Ch
    OR    CL,AH
    MOV   WORD PTR StatusWord,CX
    JMP   EmulateLoop
@TwoBits:
    MOV   AX,DX
    SAR   DX,2
    MOV   WORD PTR Regs[BX],DX
    XCHG  DL,DH
    OR    DX,DX
    LAHF
    SHR   AH,4
    AND   AX,0C03h
    OR    AL,AH
    SUB   AH,AH
    MOV   WORD PTR StatusWord,AX
    JMP   EmulateLoop
  End; { Asm }

_MOVR:                                 { MOVR  0010sssddd }

  Asm
    INC   WORD PTR Regs[7 * 2]
    MOV   BYTE PTR DoubleByte,0
    MOV   BX,AX
    MOV   DI,AX
    AND   BX,7
    SHR   DI,2
    ADD   BX,BX
    AND   DI,0Eh
    MOV   DX,WORD PTR Regs[DI]
    MOV   WORD PTR Regs[BX],DX
    OR    DX,DX
    LAHF
    SHR   AX,12
    AND   AX,0Ch
    AND   WORD PTR StatusWord,3
    OR    WORD PTR StatusWord,AX
    JMP   EmulateLoop
  End; { Asm }

_ADDR:                                 { ADDR  0011sssddd }

  Asm
    INC   WORD PTR Regs[7 * 2]
    MOV   BYTE PTR DoubleByte,0
    MOV   BX,AX
    MOV   DI,AX
    AND   BX,7
    SHR   DI,2
    ADD   BX,BX
    AND   DI,0Eh
    MOV   AX,WORD PTR Regs[DI]
    ADD   WORD PTR Regs[BX],AX
    MOV   AL,2
    LAHF
    JO    @L1
    XOR   AL,AL
@L1:
    AND   AH,0C1h
    OR    AL,AH
    SHR   AH,4
    OR    AL,AH
    AND   AX,0Fh
    MOV   WORD PTR StatusWord,AX
    JMP   EmulateLoop
  End; { Asm }

_SUBR:                                 { SUBR  0100sssddd }

  Asm
    INC   WORD PTR Regs[7 * 2]
    MOV   BYTE PTR DoubleByte,0
    MOV   BX,AX
    MOV   DI,AX
    AND   BX,7
    SHR   DI,2
    ADD   BX,BX
    AND   DI,0Eh
    MOV   AX,WORD PTR Regs[DI]
    SUB   WORD PTR Regs[BX],AX
    MOV   AL,3
    LAHF
    JO    @L1
    MOV   AL,1
@L1:
    AND   AH,0C1h
    XOR   AL,AH
    SHR   AH,4
    OR    AL,AH
    AND   AX,0Fh
    MOV   WORD PTR StatusWord,AX
    JMP   EmulateLoop
  End; { Asm }

_CMPR:                                 { CMPR  0101sssddd }

  Asm
    INC   WORD PTR Regs[7 * 2]
    MOV   BYTE PTR DoubleByte,0
    MOV   BX,AX
    MOV   DI,AX
    AND   BX,7
    SHR   DI,2
    ADD   BX,BX
    AND   DI,0Eh
    MOV   AX,WORD PTR Regs[BX]
    SUB   AX,WORD PTR Regs[DI]
    MOV   AL,3
    LAHF
    JO    @L1
    MOV   AL,1
@L1:
    AND   AH,0C1h
    XOR   AL,AH
    SHR   AH,4
    OR    AL,AH
    AND   AX,0Fh
    MOV   WORD PTR StatusWord,AX
    JMP   EmulateLoop
  End; { Asm }

_ANDR:                                 { ANDR  0110sssddd }

  Asm
    INC   WORD PTR Regs[7 * 2]
    MOV   BYTE PTR DoubleByte,0
    MOV   BX,AX
    MOV   DI,AX
    AND   BX,7
    SHR   DI,2
    ADD   BX,BX
    AND   DI,0Eh
    MOV   AX,WORD PTR Regs[DI]
    AND   WORD PTR Regs[BX],AX
    MOV   DX,WORD PTR Regs[BX]
    OR    DX,DX
    LAHF
    SHR   AX,12
    AND   AX,0Ch
    AND   WORD PTR StatusWord,3
    OR    WORD PTR StatusWord,AX
    JMP   EmulateLoop
  End; { Asm }

_XORR:                                 { XORR  0111sssddd }

  Asm
    INC   WORD PTR Regs[7 * 2]
    MOV   BYTE PTR DoubleByte,0
    MOV   BX,AX
    MOV   DI,AX
    AND   BX,7
    SHR   DI,2
    ADD   BX,BX
    AND   DI,0Eh
    MOV   AX,WORD PTR Regs[DI]
    XOR   WORD PTR Regs[BX],AX
    MOV   DX,WORD PTR Regs[BX]
    OR    DX,DX
    LAHF
    SHR   AX,12
    AND   AX,0Ch
    AND   WORD PTR StatusWord,3
    OR    WORD PTR StatusWord,AX
    JMP   EmulateLoop
  End; { Asm }

_Bxxxx:                                { Bxxxx 1000z0cccc/1000z1eeee }

  Asm
    TEST  AX,10h
    JNZ   @L1
    MOV   BX,WORD PTR StatusWord
    AND   BX,0Fh
    MOV   CX,BX
    MOV   DX,BX
    SHR   CX,2
    XOR   CX,BX    { Get S xor O }

    OR    CX,1     { Set to 1 for "always true" test }

    AND   CX,3
    SHL   CX,4
    OR    BX,CX

    SHR   CX,3     { Get Z or (S xor O) }
    OR    CX,BX
    AND   CX,4
    SHL   CX,4
    OR    BX,CX

    MOV   CX,DX
    SHR   CX,3
    XOR   CX,BX    { Get S xor C }
    AND   CX,1
    SHL   CX,7
    OR    BX,CX

    MOV   SI,AX    { Get just the condition code }
    AND   SI,0Fh
    SUB   CX,CX    { Default to false }
    TEST  SI,8
    JZ    @L2
    XOR   CX,1     { Switch defualt if "not" condition code }
    AND   SI,7     { Strip "not" part of code }
@L2:
    CMP   SI,3
    JNE   @L3
    XOR   CX,1     { Switch defualt if checking sign bit }
@L3:
    TEST  BL,BYTE PTR Condition[SI]
    JZ    @L4
    XOR   CX,1     { Switch if condition is met }
@L4:
    ADD   WORD PTR Regs[7 * 2],2
    TEST  CX,1
    JZ    @L5

    ADD   WORD PTR InsCount,2

    PUSH  AX
    MOV   SI,DI
    INC   SI
    SHR   SI,12
    SHL   SI,2
    LES   BX,DWORD PTR IntvMemPtr[SI]
    MOV   SI,DI
    INC   SI
    AND   SI,0FFFh
    ADD   SI,SI
    MOV   AX,WORD PTR ES:[BX+SI]
    MOV   DI,AX
    POP   AX

    TEST  AX,20h
    JNZ   @L6
    ADD   WORD PTR Regs[7 * 2],DI
    MOV   BYTE PTR DoubleByte,0
    JMP   EmulateLoop
@L6:
    INC   DI
    SUB   WORD PTR Regs[7 * 2],DI
@L5:
    MOV   BYTE PTR DoubleByte,0
    JMP   EmulateLoop

    { Support branch on external condition here }

@L1:
    MOV   BYTE PTR DoubleByte,0
    MOV   CL,AL
    AND   CL,0Fh
    ADD   WORD PTR Regs[7 * 2],2
    TEST  BYTE PTR EBCI,0FFh
    JZ    @L7
    MOV   BYTE PTR EBCA,CL

    ADD   WORD PTR InsCount,2

    PUSH  AX
    MOV   SI,DI
    INC   SI
    SHR   SI,12
    SHL   SI,2
    LES   BX,DWORD PTR IntvMemPtr[SI]
    MOV   SI,DI
    INC   SI
    AND   SI,0FFFh
    ADD   SI,SI
    MOV   AX,WORD PTR ES:[BX+SI]
    MOV   DI,AX
    POP   AX

    TEST  AX,20h
    JNZ   @L8
    ADD   WORD PTR Regs[7 * 2],DI
    JMP   @L7
@L8:
    INC   DI
    SUB   WORD PTR Regs[7 * 2],DI
@L7:
    MOV   BYTE PTR DoubleByte,0
    JMP   EmulateLoop
  End; { Asm }

_MVO:                                  { MVO   1001000sss }

  Asm
    AND   BYTE PTR Interrupts,0FEh
    ADD   WORD PTR Regs[7 * 2],2
    MOV   BX,AX
    AND   BX,7
    ADD   BX,BX
    PUSH  BX
    MOV   SI,DI
    INC   SI
    SHR   SI,12
    SHL   SI,2
    LES   BX,DWORD PTR IntvMemPtr[SI]
    MOV   SI,DI
    INC   SI
    AND   SI,0FFFh
    ADD   SI,SI
    MOV   AX,WORD PTR ES:[BX+SI]
    POP   BX
    MOV   DI,AX

    MOV   AX,WORD PTR Regs[BX]

    PUSH  BX
    MOV   SI,DI
    SHR   SI,12
    SHL   SI,2
    LES   BX,DWORD PTR IntvMemPtr[SI]
    MOV   SI,DI
    AND   SI,0FFFh
    ADD   SI,SI

    PUSH  ES
    PUSH  AX
    PUSH  BX
    PUSH  CX
    PUSH  DX
    PUSH  SI
    PUSH  DI

    PUSH  DI
    CALL  CanWrite
    TEST  AX,0FFh
    JZ    @NoWrite
    POP   DI
    POP   SI
    POP   DX
    POP   CX
    POP   BX
    POP   AX
    POP   ES

    MOV   WORD PTR ES:[BX+SI],AX
    POP   BX

    PUSH  DI
    PUSH  AX
    CALL  Handle_IO_Write

    JMP   EmulateLoop
@NoWrite:
    POP   DI
    POP   SI
    POP   DX
    POP   CX
    POP   BX
    POP   AX
    POP   ES

    POP   BX
    JMP   EmulateLoop
  End; { Asm }

_MVOimp:                               { MVO@  1001mmmsss   (mmm <> 0) }

  Asm
    INC   WORD PTR Regs[7 * 2]
    MOV   BX,AX
    MOV   DI,AX
    AND   BX,7
    SHR   DI,2
    ADD   BX,BX
    AND   DI,0Eh
    SUB   SI,SI
    TEST  BYTE PTR DoubleByte,1
    JNZ   @Double
    MOV   SI,WORD PTR Regs[DI]
    MOV   CX,WORD PTR Regs[BX]
    ADD   SI,WORD PTR PreWrite[DI]

    PUSH  BX
    PUSH  DI
    MOV   DI,SI
    SHR   DI,12
    SHL   DI,2
    LES   BX,DWORD PTR IntvMemPtr[DI]
    MOV   DI,SI
    AND   DI,0FFFh
    ADD   DI,DI

    PUSH  ES
    PUSH  AX
    PUSH  BX
    PUSH  CX
    PUSH  DX
    PUSH  SI
    PUSH  DI

    PUSH  SI
    CALL  CanWrite
    TEST  AX,0FFh
    JZ    @NoWrite
    POP   DI
    POP   SI
    POP   DX
    POP   CX
    POP   BX
    POP   AX
    POP   ES

    MOV   WORD PTR ES:[BX+DI],CX
    POP   DI
    POP   BX

    PUSH  SI
    PUSH  DI

    PUSH  SI
    PUSH  CX
    CALL  Handle_IO_Write

    POP   DI
    POP   SI

    ADD   SI,WORD PTR PostWrite[DI]
    MOV   WORD PTR Regs[DI],SI
    JMP   EmulateLoop
@NoWrite:
    POP   DI
    POP   SI
    POP   DX
    POP   CX
    POP   BX
    POP   AX
    POP   ES

    POP   DI
    POP   BX
    ADD   SI,WORD PTR PostWrite[DI]
    MOV   WORD PTR Regs[DI],SI
    JMP   EmulateLoop

@Double:
    MOV   SI,WORD PTR Regs[DI]
    MOV   CX,WORD PTR Regs[BX]
    ADD   SI,WORD PTR PreWrite[DI]

    PUSH  BX
    PUSH  DI
    MOV   DI,SI
    SHR   DI,12
    SHL   DI,2
    LES   BX,DWORD PTR IntvMemPtr[DI]
    MOV   DI,SI
    AND   DI,0FFFh
    ADD   DI,DI

    PUSH  ES
    PUSH  AX
    PUSH  BX
    PUSH  CX
    PUSH  DX
    PUSH  SI
    PUSH  DI

    PUSH  SI
    CALL  CanWrite
    TEST  AX,0FFh
    JZ    @NoWrite1
    POP   DI
    POP   SI
    POP   DX
    POP   CX
    POP   BX
    POP   AX
    POP   ES

    MOV   BYTE PTR ES:[BX+DI],CL
    MOV   BYTE PTR ES:[BX+DI+1],0
    POP   DI
    POP   BX

    PUSH  ES
    PUSH  AX
    PUSH  BX
    PUSH  CX
    PUSH  DX
    PUSH  SI
    PUSH  DI

    PUSH  SI
    MOV   AL,CL
    SUB   AH,AH
    PUSH  AX
    CALL  Handle_IO_Write

    POP   DI
    POP   SI
    POP   DX
    POP   CX
    POP   BX
    POP   AX
    POP   ES

    JMP   @DoNext
@NoWrite1:
    POP   DI
    POP   SI
    POP   DX
    POP   CX
    POP   BX
    POP   AX
    POP   ES

    POP   DI
    POP   BX
@DoNext:
    ADD   SI,WORD PTR PostWrite[DI]

    PUSH  BX
    PUSH  DI
    MOV   DI,SI
    SHR   DI,12
    SHL   DI,2
    LES   BX,DWORD PTR IntvMemPtr[DI]
    MOV   DI,SI
    AND   DI,0FFFh
    ADD   DI,DI

    MOV   BYTE PTR DoubleByte,0

    PUSH  ES
    PUSH  AX
    PUSH  BX
    PUSH  CX
    PUSH  DX
    PUSH  SI
    PUSH  DI

    PUSH  SI
    CALL  CanWrite
    TEST  AX,0FFh
    JZ    @NoWrite2
    POP   DI
    POP   SI
    POP   DX
    POP   CX
    POP   BX
    POP   AX
    POP   ES

    MOV   BYTE PTR ES:[BX+DI],CH
    MOV   BYTE PTR ES:[BX+DI+1],0
    POP   DI
    POP   BX

    PUSH  SI
    PUSH  DI

    PUSH  SI
    MOV   AL,CH
    SUB   AH,AH
    PUSH  AX
    CALL  Handle_IO_Write

    POP   DI
    POP   SI

    ADD   SI,WORD PTR PostWrite[DI]
    MOV   WORD PTR Regs[DI],SI
    JMP   EmulateLoop
@NoWrite2:
    POP   DI
    POP   SI
    POP   DX
    POP   CX
    POP   BX
    POP   AX
    POP   ES

    POP   DI
    POP   BX
    ADD   SI,WORD PTR PostWrite[DI]
    MOV   WORD PTR Regs[DI],SI
    JMP   EmulateLoop
  End; { Asm }

_MVI:                                  { MVI   1010000ddd }

  Asm
    ADD   WORD PTR Regs[7 * 2],2
    MOV   BX,AX
    AND   BX,7
    ADD   BX,BX

    PUSH  BX
    MOV   SI,DI
    INC   SI
    SHR   SI,12
    SHL   SI,2
    LES   BX,DWORD PTR IntvMemPtr[SI]
    MOV   SI,DI
    INC   SI
    AND   SI,0FFFh
    ADD   SI,SI
    MOV   AX,WORD PTR ES:[BX+SI]
    POP   BX

    MOV   DI,AX

    PUSH  BX
    MOV   SI,DI
    SHR   SI,12
    SHL   SI,2
    LES   BX,DWORD PTR IntvMemPtr[SI]
    MOV   SI,DI
    AND   SI,0FFFh
    ADD   SI,SI
    MOV   AX,WORD PTR ES:[BX+SI]
{    POP   BX}

    PUSH  AX
    PUSH  BX
    PUSH  CX
    PUSH  DX
    PUSH  SI
    PUSH  DI
    PUSH  ES

    PUSH  DI
    PUSH  AX
    CALL  Handle_IO_Read

    POP   ES
    POP   DI
    POP   SI
    POP   DX
    POP   CX
    POP   BX
    POP   AX

    MOV   AX,WORD PTR ES:[BX+SI]
    POP   BX

    MOV   WORD PTR Regs[BX],AX
    JMP   EmulateLoop
@L1:

    PUSH  BX
    MOV   SI,DI
    INC   SI
    SHR   SI,12
    SHL   SI,2
    LES   BX,DWORD PTR IntvMemPtr[SI]
    MOV   SI,DI
    INC   SI
    AND   SI,0FFFh
    ADD   SI,SI
    MOV   CL,BYTE PTR ES:[BX+SI]

    MOV   SI,DI
    ADD   SI,2
    SHR   SI,12
    SHL   SI,2
    LES   BX,DWORD PTR IntvMemPtr[SI]
    MOV   SI,DI
    ADD   SI,2
    AND   SI,0FFFh
    ADD   SI,SI
    MOV   CH,BYTE PTR ES:[BX+SI]
    POP   BX

    MOV   DI,CX

    PUSH  BX
    MOV   SI,DI
    SHR   SI,12
    SHL   SI,2
    LES   BX,DWORD PTR IntvMemPtr[SI]
    MOV   SI,DI
    AND   SI,0FFFh
    ADD   SI,SI
    MOV   AX,WORD PTR ES:[BX+SI]
{    POP   BX}

    PUSH  AX
    PUSH  BX
    PUSH  CX
    PUSH  DX
    PUSH  SI
    PUSH  DI
    PUSH  ES

    PUSH  DI
    PUSH  AX
    CALL  Handle_IO_Read

    POP   ES
    POP   DI
    POP   SI
    POP   DX
    POP   CX
    POP   BX
    POP   AX

    MOV   AX,WORD PTR ES:[BX+SI]
    POP   BX

    MOV   WORD PTR Regs[BX],AX
    MOV   BYTE PTR DoubleByte,0
    JMP   EmulateLoop
  End; { Asm }

_MVIimp:                               { MVI@  1010mmmddd   (mmm <> 0) }

  Asm
    INC   WORD PTR Regs[7 * 2]
    MOV   BX,AX
    MOV   DI,AX
    AND   BX,7
    SHR   DI,2
    ADD   BX,BX
    AND   DI,0Eh
    SUB   SI,SI
    TEST  BYTE PTR DoubleByte,1
    JNZ   @Double
    MOV   SI,WORD PTR Regs[DI]
    ADD   SI,WORD PTR PreRead[DI]

    PUSH  BX
    PUSH  DI
    MOV   DI,SI
    SHR   DI,12
    SHL   DI,2
    LES   BX,DWORD PTR IntvMemPtr[DI]
    MOV   DI,SI
    AND   DI,0FFFh
    ADD   DI,DI
    MOV   CX,WORD PTR ES:[BX+DI]
{    POP   DI
    POP   BX}

    PUSH  AX
    PUSH  BX
    PUSH  CX
    PUSH  DX
    PUSH  SI
    PUSH  DI
    PUSH  ES

    PUSH  SI
    PUSH  CX
    CALL  Handle_IO_Read

    POP   ES
    POP   DI
    POP   SI
    POP   DX
    POP   CX
    POP   BX
    POP   AX

    MOV   CX,WORD PTR ES:[BX+DI]
    POP   DI
    POP   BX

    MOV   WORD PTR Regs[BX],CX
    ADD   SI,WORD PTR PostRead[DI]
    CMP   DI,BX
    JE    @NoUpdate
    MOV   WORD PTR Regs[DI],SI
@NoUpdate:
    JMP   EmulateLoop

@Double:
    MOV   SI,WORD PTR Regs[DI]
    ADD   SI,WORD PTR PreRead[DI]

    PUSH  BX
    PUSH  DI
    MOV   DI,SI
    SHR   DI,12
    SHL   DI,2
    LES   BX,DWORD PTR IntvMemPtr[DI]
    MOV   DI,SI
    AND   DI,0FFFh
    ADD   DI,DI
    MOV   CL,BYTE PTR ES:[BX+DI]
{    POP   DI}

    PUSH  AX
    PUSH  BX
    PUSH  CX
    PUSH  DX
    PUSH  SI
    PUSH  DI
    PUSH  ES

    PUSH  SI
    PUSH  CX
    CALL  Handle_IO_Read

    POP   ES
    POP   DI
    POP   SI
    POP   DX
    POP   CX
    POP   BX
    POP   AX

    MOV   CL,BYTE PTR ES:[BX+DI]
    POP   DI

    ADD   SI,WORD PTR PostRead[DI]
    PUSH  DI
    MOV   DI,SI
    SHR   DI,12
    SHL   DI,2
    LES   BX,DWORD PTR IntvMemPtr[DI]
    MOV   DI,SI
    AND   DI,0FFFh
    ADD   DI,DI
    MOV   CH,BYTE PTR ES:[BX+DI]
{    POP   DI}

    PUSH  AX
    PUSH  BX
    PUSH  CX
    PUSH  DX
    PUSH  SI
    PUSH  DI
    PUSH  ES

    PUSH  SI
    PUSH  CX
    CALL  Handle_IO_Read

    POP   ES
    POP   DI
    POP   SI
    POP   DX
    POP   CX
    POP   BX
    POP   AX

    MOV   CH,BYTE PTR ES:[BX+DI]
    POP   DI

    ADD   SI,WORD PTR PostRead[DI]
    POP   BX
    MOV   WORD PTR Regs[BX],CX
    CMP   DI,BX
    JE    @NoUpdate1
    MOV   WORD PTR Regs[DI],SI
@NoUpdate1:
    MOV   BYTE PTR DoubleByte,0
    JMP   EmulateLoop
  End; { Asm }

_ADD:                                  { ADD   1011000ddd }

  Asm
    ADD   WORD PTR Regs[7 * 2],2
    MOV   BX,AX
    AND   BX,7
    ADD   BX,BX

    PUSH  BX
    MOV   SI,DI
    INC   SI
    SHR   SI,12
    SHL   SI,2
    LES   BX,DWORD PTR IntvMemPtr[SI]
    MOV   SI,DI
    INC   SI
    AND   SI,0FFFh
    ADD   SI,SI
    MOV   AX,WORD PTR ES:[BX+SI]
    POP   BX

    MOV   DI,AX

    PUSH  BX
    MOV   SI,DI
    SHR   SI,12
    SHL   SI,2
    LES   BX,DWORD PTR IntvMemPtr[SI]
    MOV   SI,DI
    AND   SI,0FFFh
    ADD   SI,SI
    MOV   AX,WORD PTR ES:[BX+SI]
{    POP   BX}

    PUSH  AX
    PUSH  BX
    PUSH  CX
    PUSH  DX
    PUSH  SI
    PUSH  DI
    PUSH  ES

    PUSH  DI
    PUSH  AX
    CALL  Handle_IO_Read

    POP   ES
    POP   DI
    POP   SI
    POP   DX
    POP   CX
    POP   BX
    POP   AX

    MOV   AX,WORD PTR ES:[BX+SI]
    POP   BX

    ADD   WORD PTR Regs[BX],AX
    MOV   AL,2
    LAHF
    JO    @L1
    XOR   AL,AL
@L1:
    AND   AH,0C1h
    OR    AL,AH
    SHR   AH,4
    OR    AL,AH
    AND   AX,0Fh
    MOV   WORD PTR StatusWord,AX
    JMP   EmulateLoop
  End; { Asm }

_ADDimp:                               { ADD@  1011mmmddd   (mmm <> 0) }

  Asm
    MOV   WORD PTR StatusWord,0
    INC   WORD PTR Regs[7 * 2]
    MOV   BX,AX
    MOV   DI,AX
    AND   BX,7
    SHR   DI,2
    ADD   BX,BX
    AND   DI,0Eh
    SUB   SI,SI
    TEST  BYTE PTR DoubleByte,1
    JNZ   @Double
    MOV   SI,WORD PTR Regs[DI]
    ADD   SI,WORD PTR PreRead[DI]

    PUSH  BX
    PUSH  DI
    MOV   DI,SI
    SHR   DI,12
    SHL   DI,2
    LES   BX,DWORD PTR IntvMemPtr[DI]
    MOV   DI,SI
    AND   DI,0FFFh
    ADD   DI,DI
    MOV   CX,WORD PTR ES:[BX+DI]
{    POP   DI
    POP   BX}

    PUSH  AX
    PUSH  BX
    PUSH  CX
    PUSH  DX
    PUSH  SI
    PUSH  DI
    PUSH  ES

    PUSH  SI
    PUSH  CX
    CALL  Handle_IO_Read

    POP   ES
    POP   DI
    POP   SI
    POP   DX
    POP   CX
    POP   BX
    POP   AX

    MOV   CX,WORD PTR ES:[BX+DI]
    POP   DI
    POP   BX

    JMP   @L5

@Double:
    MOV   BYTE PTR DoubleByte,0
    MOV   SI,WORD PTR Regs[DI]
    ADD   SI,WORD PTR PreRead[DI]

    PUSH  BX
    PUSH  DI
    MOV   DI,SI
    SHR   DI,12
    SHL   DI,2
    LES   BX,DWORD PTR IntvMemPtr[DI]
    MOV   DI,SI
    AND   DI,0FFFh
    ADD   DI,DI
    MOV   CL,BYTE PTR ES:[BX+DI]
{    POP   DI}

    PUSH  AX
    PUSH  BX
    PUSH  CX
    PUSH  DX
    PUSH  SI
    PUSH  DI
    PUSH  ES

    PUSH  SI
    PUSH  CX
    CALL  Handle_IO_Read

    POP   ES
    POP   DI
    POP   SI
    POP   DX
    POP   CX
    POP   BX
    POP   AX

    MOV   CL,BYTE PTR ES:[BX+DI]
    POP   DI

    ADD   SI,WORD PTR PostRead[DI]
    PUSH  DI
    MOV   DI,SI
    SHR   DI,12
    SHL   DI,2
    LES   BX,DWORD PTR IntvMemPtr[DI]
    MOV   DI,SI
    AND   DI,0FFFh
    ADD   DI,DI
    MOV   CH,BYTE PTR ES:[BX+DI]
{    POP   DI
    POP   BX}

    PUSH  AX
    PUSH  BX
    PUSH  CX
    PUSH  DX
    PUSH  SI
    PUSH  DI
    PUSH  ES

    PUSH  SI
    PUSH  CX
    CALL  Handle_IO_Read

    POP   ES
    POP   DI
    POP   SI
    POP   DX
    POP   CX
    POP   BX
    POP   AX

    MOV   CH,BYTE PTR ES:[BX+DI]
    POP   DI
    POP   BX

@L5:

    ADD   SI,WORD PTR PostRead[DI]
    MOV   WORD PTR Regs[DI],SI

    ADD   WORD PTR Regs[BX],CX
    MOV   AL,2
    LAHF
    JO    @L1
    XOR   AL,AL
@L1:
    AND   AH,0C1h
    OR    AL,AH
    SHR   AH,4
    OR    AL,AH
    AND   AX,0Fh
    MOV   WORD PTR StatusWord,AX
    JMP   EmulateLoop
  End; { Asm }

_SUB:                                  { SUB   1100000ddd }

  Asm
    ADD   WORD PTR Regs[7 * 2],2
    MOV   BX,AX
    AND   BX,7
    ADD   BX,BX

    PUSH  BX
    MOV   SI,DI
    INC   SI
    SHR   SI,12
    SHL   SI,2
    LES   BX,DWORD PTR IntvMemPtr[SI]
    MOV   SI,DI
    INC   SI
    AND   SI,0FFFh
    ADD   SI,SI
    MOV   AX,WORD PTR ES:[BX+SI]
    POP   BX

    MOV   DI,AX

    PUSH  BX
    MOV   SI,DI
    SHR   SI,12
    SHL   SI,2
    LES   BX,DWORD PTR IntvMemPtr[SI]
    MOV   SI,DI
    AND   SI,0FFFh
    ADD   SI,SI
    MOV   AX,WORD PTR ES:[BX+SI]
{    POP   BX}

    PUSH  AX
    PUSH  BX
    PUSH  CX
    PUSH  DX
    PUSH  SI
    PUSH  DI
    PUSH  ES

    PUSH  DI
    PUSH  AX
    CALL  Handle_IO_Read

    POP   ES
    POP   DI
    POP   SI
    POP   DX
    POP   CX
    POP   BX
    POP   AX

    MOV   AX,WORD PTR ES:[BX+SI]
    POP   BX

    SUB   WORD PTR Regs[BX],AX
    MOV   AL,3
    LAHF
    JO    @L1
    MOV   AL,1
@L1:
    AND   AH,0C1h
    XOR   AL,AH
    SHR   AH,4
    OR    AL,AH
    AND   AX,0Fh
    MOV   WORD PTR StatusWord,AX
    JMP   EmulateLoop
  End; { Asm }

_SUBimp:                               { SUB@  1100mmmddd   (mmm <> 0) }

  Asm
    MOV   WORD PTR StatusWord,0
    INC   WORD PTR Regs[7 * 2]
    MOV   BX,AX
    MOV   DI,AX
    AND   BX,7
    SHR   DI,2
    ADD   BX,BX
    AND   DI,0Eh
    SUB   SI,SI
    TEST  BYTE PTR DoubleByte,1
    JNZ   @L4
    MOV   SI,WORD PTR Regs[DI]
    ADD   SI,WORD PTR PreRead[DI]

    PUSH  BX
    PUSH  DI
    MOV   DI,SI
    SHR   DI,12
    SHL   DI,2
    LES   BX,DWORD PTR IntvMemPtr[DI]
    MOV   DI,SI
    AND   DI,0FFFh
    ADD   DI,DI
    MOV   CX,WORD PTR ES:[BX+DI]
{    POP   DI
    POP   BX}

    PUSH  AX
    PUSH  BX
    PUSH  CX
    PUSH  DX
    PUSH  SI
    PUSH  DI
    PUSH  ES

    PUSH  SI
    PUSH  CX
    CALL  Handle_IO_Read

    POP   ES
    POP   DI
    POP   SI
    POP   DX
    POP   CX
    POP   BX
    POP   AX

    MOV   CX,WORD PTR ES:[BX+DI]
    POP   DI
    POP   BX

    JMP   @L5
@L4:
    MOV   BYTE PTR DoubleByte,0
    MOV   SI,WORD PTR Regs[DI]
    ADD   SI,WORD PTR PreRead[DI]

    PUSH  BX
    PUSH  DI
    MOV   DI,SI
    SHR   DI,12
    SHL   DI,2
    LES   BX,DWORD PTR IntvMemPtr[DI]
    MOV   DI,SI
    AND   DI,0FFFh
    ADD   DI,DI
    MOV   CL,BYTE PTR ES:[BX+DI]

    ADD   BX,DI

    POP   DI
    ADD   SI,WORD PTR PostRead[DI]

    PUSH  AX
    PUSH  BX
    PUSH  CX
    PUSH  DX
    PUSH  SI
    PUSH  DI
    PUSH  ES

    PUSH  SI
    PUSH  CX
    CALL  Handle_IO_Read

    POP   ES
    POP   DI
    POP   SI
    POP   DX
    POP   CX
    POP   BX
    POP   AX

    MOV   CL,BYTE PTR ES:[BX]

    PUSH  DI
    MOV   DI,SI
    SHR   DI,12
    SHL   DI,2
    LES   BX,DWORD PTR IntvMemPtr[DI]
    MOV   DI,SI
    AND   DI,0FFFh
    ADD   DI,DI
    MOV   CH,BYTE PTR ES:[BX+DI]
{    POP   DI
    POP   BX}

    PUSH  AX
    PUSH  BX
    PUSH  CX
    PUSH  DX
    PUSH  SI
    PUSH  DI

    PUSH  SI
    PUSH  CX
    CALL  Handle_IO_Read

    POP   DI
    POP   SI
    POP   DX
    POP   CX
    POP   BX
    POP   AX

    MOV   CH,BYTE PTR ES:[BX+DI]
    POP   DI
    POP   BX

@L5:
    ADD   SI,WORD PTR PostRead[DI]
    MOV   WORD PTR Regs[DI],SI

    SUB   WORD PTR Regs[BX],CX
    MOV   AL,3
    LAHF
    JO    @L1
    MOV   AL,1
@L1:
    AND   AH,0C1h
    XOR   AL,AH
    SHR   AH,4
    OR    AL,AH
    AND   AX,0Fh
    MOV   WORD PTR StatusWord,AX
    JMP   EmulateLoop
  End; { Asm }

_CMP:                                  { CMP   1101000ddd }

  Asm
    ADD   WORD PTR Regs[7 * 2],2
    MOV   BX,AX
    AND   BX,7
    ADD   BX,BX

    PUSH  BX
    MOV   SI,DI
    INC   SI
    SHR   SI,12
    SHL   SI,2
    LES   BX,DWORD PTR IntvMemPtr[SI]
    MOV   SI,DI
    INC   SI
    AND   SI,0FFFh
    ADD   SI,SI
    MOV   AX,WORD PTR ES:[BX+SI]
    POP   BX

    MOV   DI,AX

    PUSH  BX
    MOV   SI,DI
    SHR   SI,12
    SHL   SI,2
    LES   BX,DWORD PTR IntvMemPtr[SI]
    MOV   SI,DI
    AND   SI,0FFFh
    ADD   SI,SI
    MOV   AX,WORD PTR ES:[BX+SI]
{    POP   BX}

    PUSH  AX
    PUSH  BX
    PUSH  CX
    PUSH  DX
    PUSH  SI
    PUSH  DI
    PUSH  ES

    PUSH  DI
    PUSH  AX
    CALL  Handle_IO_Read

    POP   ES
    POP   DI
    POP   SI
    POP   DX
    POP   CX
    POP   BX
    POP   AX

    MOV   AX,WORD PTR ES:[BX+SI]
    POP   BX

    MOV   DX,WORD PTR Regs[BX]
    SUB   DX,AX
    MOV   AL,3
    LAHF
    JO    @L1
    MOV   AL,1
@L1:
    AND   AH,0C1h
    XOR   AL,AH
    SHR   AH,4
    OR    AL,AH
    AND   AX,0Fh
    MOV   WORD PTR StatusWord,AX
    JMP   EmulateLoop
  End; { Asm }

_CMPimp:                               { CMP@  1101mmmddd   (mmm <> 0) }

  Asm
    MOV   WORD PTR StatusWord,0
    INC   WORD PTR Regs[7 * 2]
    MOV   BX,AX
    MOV   DI,AX
    AND   BX,7
    SHR   DI,2
    ADD   BX,BX
    AND   DI,0Eh
    SUB   SI,SI
    TEST  BYTE PTR DoubleByte,1
    JNZ   @L4
    MOV   SI,WORD PTR Regs[DI]
    ADD   SI,WORD PTR PreRead[DI]

    PUSH  BX
    PUSH  DI
    MOV   DI,SI
    SHR   DI,12
    SHL   DI,2
    LES   BX,DWORD PTR IntvMemPtr[DI]
    MOV   DI,SI
    AND   DI,0FFFh
    ADD   DI,DI
    MOV   CX,WORD PTR ES:[BX+DI]
{    POP   DI
    POP   BX}

    PUSH  AX
    PUSH  BX
    PUSH  CX
    PUSH  DX
    PUSH  SI
    PUSH  DI
    PUSH  ES

    PUSH  SI
    PUSH  CX
    CALL  Handle_IO_Read

    POP   ES
    POP   DI
    POP   SI
    POP   DX
    POP   CX
    POP   BX
    POP   AX

    MOV   CX,WORD PTR ES:[BX+DI]
    POP   DI
    POP   BX

    JMP   @L5
@L4:
    MOV   BYTE PTR DoubleByte,0
    MOV   SI,WORD PTR Regs[DI]
    ADD   SI,WORD PTR PreRead[DI]

    PUSH  BX
    PUSH  DI
    MOV   DI,SI
    SHR   DI,12
    SHL   DI,2
    LES   BX,DWORD PTR IntvMemPtr[DI]
    MOV   DI,SI
    AND   DI,0FFFh
    ADD   DI,DI
    MOV   CL,BYTE PTR ES:[BX+DI]
{    POP   DI}

    PUSH  AX
    PUSH  BX
    PUSH  CX
    PUSH  DX
    PUSH  SI
    PUSH  DI
    PUSH  ES

    PUSH  SI
    PUSH  CX
    CALL  Handle_IO_Read

    POP   ES
    POP   DI
    POP   SI
    POP   DX
    POP   CX
    POP   BX
    POP   AX

    MOV   CL,BYTE PTR ES:[BX+DI]
    POP   DI

    ADD   SI,WORD PTR PostRead[DI]
    PUSH  DI
    MOV   DI,SI
    SHR   DI,12
    SHL   DI,2
    LES   BX,DWORD PTR IntvMemPtr[DI]
    MOV   DI,SI
    AND   DI,0FFFh
    ADD   DI,DI
    MOV   CH,BYTE PTR ES:[BX+DI]
{    POP   DI
    POP   BX}

    PUSH  AX
    PUSH  BX
    PUSH  CX
    PUSH  DX
    PUSH  SI
    PUSH  DI
    PUSH  ES

    PUSH  SI
    PUSH  CX
    CALL  Handle_IO_Read

    POP   ES
    POP   DI
    POP   SI
    POP   DX
    POP   CX
    POP   BX
    POP   AX

    MOV   CH,BYTE PTR ES:[BX+DI]
    POP   DI
    POP   BX

@L5:
    ADD   SI,WORD PTR PostRead[DI]
    MOV   WORD PTR Regs[DI],SI

    MOV   DX,WORD PTR Regs[BX]
    SUB   DX,CX
    MOV   AL,3
    LAHF
    JO    @L1
    MOV   AL,1
@L1:
    AND   AH,0C1h
    XOR   AL,AH
    SHR   AH,4
    OR    AL,AH
    AND   AX,0Fh
    MOV   WORD PTR StatusWord,AX
    JMP   EmulateLoop
  End; { Asm }

_AND:                                  { AND   1110000ddd }

  Asm
    ADD   WORD PTR Regs[7 * 2],2
    MOV   BX,AX
    AND   BX,7
    ADD   BX,BX

    PUSH  BX
    MOV   SI,DI
    INC   SI
    SHR   SI,12
    SHL   SI,2
    LES   BX,DWORD PTR IntvMemPtr[SI]
    MOV   SI,DI
    INC   SI
    AND   SI,0FFFh
    ADD   SI,SI
    MOV   AX,WORD PTR ES:[BX+SI]
    POP   BX

    MOV   DI,AX

    PUSH  BX
    MOV   SI,DI
    SHR   SI,12
    SHL   SI,2
    LES   BX,DWORD PTR IntvMemPtr[SI]
    MOV   SI,DI
    AND   SI,0FFFh
    ADD   SI,SI
    MOV   AX,WORD PTR ES:[BX+SI]
{    POP   BX}

    PUSH  AX
    PUSH  BX
    PUSH  CX
    PUSH  DX
    PUSH  SI
    PUSH  DI
    PUSH  ES

    PUSH  DI
    PUSH  AX
    CALL  Handle_IO_Read

    POP   ES
    POP   DI
    POP   SI
    POP   DX
    POP   CX
    POP   BX
    POP   AX

    MOV   AX,WORD PTR ES:[BX+SI]
    POP   BX

    AND   WORD PTR Regs[BX],AX
    MOV   DX,WORD PTR Regs[BX]
    OR    DX,DX
    LAHF
    SHR   AX,12
    AND   AX,0Ch
    AND   WORD PTR StatusWord,3
    OR    WORD PTR StatusWord,AX
    JMP   EmulateLoop
  End; { Asm }

_ANDimp:                               { AND@  1110mmmddd   (mmm <> 0) }

  Asm
    INC   WORD PTR Regs[7 * 2]
    MOV   BX,AX
    MOV   DI,AX
    AND   BX,7
    SHR   DI,2
    ADD   BX,BX
    AND   DI,0Eh
    SUB   SI,SI
    TEST  BYTE PTR DoubleByte,1
    JNZ   @L4
    MOV   SI,WORD PTR Regs[DI]
    ADD   SI,WORD PTR PreRead[DI]

    PUSH  BX
    PUSH  DI
    MOV   DI,SI
    SHR   DI,12
    SHL   DI,2
    LES   BX,DWORD PTR IntvMemPtr[DI]
    MOV   DI,SI
    AND   DI,0FFFh
    ADD   DI,DI
    MOV   CX,WORD PTR ES:[BX+DI]
{    POP   DI
    POP   BX}

    PUSH  AX
    PUSH  BX
    PUSH  CX
    PUSH  DX
    PUSH  SI
    PUSH  DI
    PUSH  ES

    PUSH  SI
    PUSH  CX
    CALL  Handle_IO_Read

    POP   ES
    POP   DI
    POP   SI
    POP   DX
    POP   CX
    POP   BX
    POP   AX

    MOV   CX,WORD PTR ES:[BX+DI]
    POP   DI
    POP   BX

    JMP   @L5
@L4:
    MOV   BYTE PTR DoubleByte,0
    MOV   SI,WORD PTR Regs[DI]
    ADD   SI,WORD PTR PreRead[DI]

    PUSH  BX
    PUSH  DI
    MOV   DI,SI
    SHR   DI,12
    SHL   DI,2
    LES   BX,DWORD PTR IntvMemPtr[DI]
    MOV   DI,SI
    AND   DI,0FFFh
    ADD   DI,DI
    MOV   CL,BYTE PTR ES:[BX+DI]
{    POP   DI}

    PUSH  AX
    PUSH  BX
    PUSH  CX
    PUSH  DX
    PUSH  SI
    PUSH  DI
    PUSH  ES

    PUSH  SI
    PUSH  CX
    CALL  Handle_IO_Read

    POP   ES
    POP   DI
    POP   SI
    POP   DX
    POP   CX
    POP   BX
    POP   AX

    MOV   CL,BYTE PTR ES:[BX+DI]
    POP   DI

    ADD   SI,WORD PTR PostRead[DI]
    PUSH  DI
    MOV   DI,SI
    SHR   DI,12
    SHL   DI,2
    LES   BX,DWORD PTR IntvMemPtr[DI]
    MOV   DI,SI
    AND   DI,0FFFh
    ADD   DI,DI
    MOV   CH,BYTE PTR ES:[BX+DI]
{    POP   DI
    POP   BX}

    PUSH  AX
    PUSH  BX
    PUSH  CX
    PUSH  DX
    PUSH  SI
    PUSH  DI
    PUSH  ES

    PUSH  SI
    PUSH  CX
    CALL  Handle_IO_Read

    POP   ES
    POP   DI
    POP   SI
    POP   DX
    POP   CX
    POP   BX
    POP   AX

    MOV   CH,BYTE PTR ES:[BX+DI]
    POP   DI
    POP   BX

@L5:
    ADD   SI,WORD PTR PostRead[DI]
    MOV   WORD PTR Regs[DI],SI

    AND   WORD PTR Regs[BX],CX
    MOV   DX,WORD PTR Regs[BX]
    OR    DX,DX
    LAHF
    SHR   AX,12
    AND   AX,0Ch
    AND   WORD PTR StatusWord,3
    OR    WORD PTR StatusWord,AX
    JMP   EmulateLoop
  End; { Asm }

_XOR:                                  { XOR   1111000ddd }

  Asm
    ADD   WORD PTR Regs[7 * 2],2
    MOV   BX,AX
    AND   BX,7
    ADD   BX,BX

    PUSH  BX
    MOV   SI,DI
    INC   SI
    SHR   SI,12
    SHL   SI,2
    LES   BX,DWORD PTR IntvMemPtr[SI]
    MOV   SI,DI
    INC   SI
    AND   SI,0FFFh
    ADD   SI,SI
    MOV   AX,WORD PTR ES:[BX+SI]
    POP   BX

    MOV   DI,AX

    PUSH  BX
    MOV   SI,DI
    SHR   SI,12
    SHL   SI,2
    LES   BX,DWORD PTR IntvMemPtr[SI]
    MOV   SI,DI
    AND   SI,0FFFh
    ADD   SI,SI
    MOV   AX,WORD PTR ES:[BX+SI]
{    POP   BX}

    PUSH  AX
    PUSH  BX
    PUSH  CX
    PUSH  DX
    PUSH  SI
    PUSH  DI
    PUSH  ES

    PUSH  DI
    PUSH  AX
    CALL  Handle_IO_Read

    POP   ES
    POP   DI
    POP   SI
    POP   DX
    POP   CX
    POP   BX
    POP   AX

    MOV   AX,WORD PTR ES:[BX+SI]
    POP   BX

    XOR   WORD PTR Regs[BX],AX
    MOV   DX,WORD PTR Regs[BX]
    OR    DX,DX
    LAHF
    SHR   AX,12
    AND   AX,0Ch
    AND   WORD PTR StatusWord,3
    OR    WORD PTR StatusWord,AX
    JMP   EmulateLoop
  End; { Asm }

_XORimp:                               { XOR@  1111mmmddd   (mmm <> 0) }

  Asm
    INC   WORD PTR Regs[7 * 2]
    MOV   BX,AX
    MOV   DI,AX
    AND   BX,7
    SHR   DI,2
    ADD   BX,BX
    AND   DI,0Eh
    SUB   SI,SI
    TEST  BYTE PTR DoubleByte,1
    JNZ   @L4
    MOV   SI,WORD PTR Regs[DI]
    ADD   SI,WORD PTR PreRead[DI]

    PUSH  BX
    PUSH  DI
    MOV   DI,SI
    SHR   DI,12
    SHL   DI,2
    LES   BX,DWORD PTR IntvMemPtr[DI]
    MOV   DI,SI
    AND   DI,0FFFh
    ADD   DI,DI
    MOV   CX,WORD PTR ES:[BX+DI]
{    POP   DI
    POP   BX}

    PUSH  AX
    PUSH  BX
    PUSH  CX
    PUSH  DX
    PUSH  SI
    PUSH  DI
    PUSH  ES

    PUSH  SI
    PUSH  CX
    CALL  Handle_IO_Read

    POP   ES
    POP   DI
    POP   SI
    POP   DX
    POP   CX
    POP   BX
    POP   AX

    MOV   CX,WORD PTR ES:[BX+DI]
    POP   DI
    POP   BX

    JMP   @L5
@L4:
    MOV   BYTE PTR DoubleByte,0
    MOV   SI,WORD PTR Regs[DI]
    ADD   SI,WORD PTR PreRead[DI]

    PUSH  BX
    PUSH  DI
    MOV   DI,SI
    SHR   DI,12
    SHL   DI,2
    LES   BX,DWORD PTR IntvMemPtr[DI]
    MOV   DI,SI
    AND   DI,0FFFh
    ADD   DI,DI
    MOV   CL,BYTE PTR ES:[BX+DI]
{    POP   DI}

    PUSH  AX
    PUSH  BX
    PUSH  CX
    PUSH  DX
    PUSH  SI
    PUSH  DI
    PUSH  ES

    PUSH  SI
    PUSH  CX
    CALL  Handle_IO_Read

    POP   ES
    POP   DI
    POP   SI
    POP   DX
    POP   CX
    POP   BX
    POP   AX

    MOV   CL,BYTE PTR ES:[BX+DI]
    POP   DI

    ADD   SI,WORD PTR PostRead[DI]
    PUSH  DI
    MOV   DI,SI
    SHR   DI,12
    SHL   DI,2
    LES   BX,DWORD PTR IntvMemPtr[DI]
    MOV   DI,SI
    AND   DI,0FFFh
    ADD   DI,DI
    MOV   CH,BYTE PTR ES:[BX+DI]
{    POP   DI
    POP   BX}

    PUSH  AX
    PUSH  BX
    PUSH  CX
    PUSH  DX
    PUSH  SI
    PUSH  DI
    PUSH  ES

    PUSH  SI
    PUSH  CX
    CALL  Handle_IO_Read

    POP   ES
    POP   DI
    POP   SI
    POP   DX
    POP   CX
    POP   BX
    POP   AX

    MOV   CH,BYTE PTR ES:[BX+DI]
    POP   DI
    POP   BX

@L5:
    ADD   SI,WORD PTR PostRead[DI]
    MOV   WORD PTR Regs[DI],SI

    XOR   WORD PTR Regs[BX],CX
    MOV   DX,WORD PTR Regs[BX]
    OR    DX,DX
    LAHF
    SHR   AX,12
    AND   AX,0Ch
    AND   WORD PTR StatusWord,3
    OR    WORD PTR StatusWord,AX
    JMP   EmulateLoop
  End; { Asm }
End; { Emulate }

procedure FormShow;
Var
  I : Word;
  F : File;

begin
  GetDir(0,CurrentDir);

  For I := 0    To 65535 Do IntvMemPtr[I Shr 12]^[I And $FFF] := $FC00;
  For I := $200 To $2EF  Do IntvMemPtr[I Shr 12]^[I And $FFF] := 0;
  For I := 0    To $32   Do IntvMemPtr[I Shr 12]^[I And $FFF] := 0;

  For I := $33  To $FF   Do IntvMemPtr[I Shr 12]^[I And $FFF] := $FFFF;

  SetPalette(Palette,False);
  Emulating  := False;
  Breakpoint := 0;
  Breaking   := False;
  NewList    := True;
  ScreenMode := smColorStack;
end; { FormShow }

Procedure UnprotectCRTC; Assembler;
Asm

  { Un-protect the CRTC registers }

  MOV   DX,CRTC_INDEX
  MOV   AL,END_VERT_RETRACE
  OUT   DX,AL
  INC   DX
  IN    AL,DX
  AND   AL,7Fh
  OUT   DX,AL
  DEC   DX
  MOV   AL,END_HORZ_BLANK
  OUT   DX,AL
  INC   DX
  IN    AL,DX
  OR    AL,80h
  OUT   DX,AL
End; { UnprotectCRTC }

Procedure ProtectCRTC; Assembler;
Asm

  { Re-protect the CRTC registers }

  MOV   DX,CRTC_INDEX
  MOV   AL,END_HORZ_BLANK
  OUT   DX,AL
  INC   DX
  IN    AL,DX
  AND   AL,7Fh
  OUT   DX,AL
  DEC   DX
  MOV   AL,END_VERT_RETRACE
  OUT   DX,AL
  INC   DX
  IN    AL,DX
  OR    AL,80h
  OUT   DX,AL
End; { ProtectCRTC }

Procedure SetRows(Rows: Word);
{ Variation on the SetRows procedure in unit PROTMENU; this method is more }
{ flexible and robust than the previous version.                           }
Var
  VT,VRS,VRE,VDE,VBS,VBE,LC                 : Word;
  _VT,_OV,_MSL,_VRS,_VRE,_VDE,_VBS,_VBE,_LC : Word;
  OriginalRows                              : Word;
  MiscReg                                   : Byte;
  Multiplier                                : Word;

Begin

  { Save the number of rows that we're told to do, since Rows can be }
  { recalculated.                                                    }

  OriginalRows := Rows;

  { Important to initialize these since they are words }

  _VT  := 0;
  _OV  := 0;
  _MSL := 0;
  _VRS := 0;
  _VRE := 0;
  _VDE := 0;
  _VBS := 0;
  _VBE := 0;
  _LC  := 0;

  UnprotectCRTC;

  { Read the VGA Miscellaneous Register }

  Asm
    MOV   DX,MISC_INPUT
    IN    AL,DX
    MOV   BYTE PTR MiscReg,AL
  End; { Asm }

  { Get the current CRTC register values }

  Asm
    MOV   DX,CRTC_INDEX

    MOV   AL,VERT_TOTAL
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    DEC   DX
    MOV   BYTE PTR _VT,AL

    MOV   AL,OVERFLOW
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    DEC   DX
    MOV   BYTE PTR _OV,AL

    MOV   AL,MAX_SCAN_LINE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    DEC   DX
    MOV   BYTE PTR _MSL,AL

    MOV   AL,START_VERT_RETRACE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    DEC   DX
    MOV   BYTE PTR _VRS,AL

    MOV   AL,END_VERT_RETRACE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    DEC   DX
    MOV   BYTE PTR _VRE,AL

    MOV   AL,VERT_DISPLAY_END
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    DEC   DX
    MOV   BYTE PTR _VDE,AL

    MOV   AL,START_VERT_BLANK
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    DEC   DX
    MOV   BYTE PTR _VBS,AL

    MOV   AL,END_VERT_BLANK
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    DEC   DX
    MOV   BYTE PTR _VBE,AL

    MOV   AL,LINE_COMPARE
    OUT   DX,AL
    INC   DX
    IN    AL,DX
    DEC   DX
    MOV   BYTE PTR _LC,AL
  End; { Asm }

  { Retrieve the full values }

  VT  := ((_OV And $20) Shr 4) + (_OV And 1);
  VT  := (VT Shl 8) + _VT;

  VRS := ((_OV And $80) Shr 6) + ((_OV And 4) Shr 2);
  VRS := (VRS Shl 8) + _VRS;

  VRE := (VRS And $FFF0) + (_VRE And $F);
  If VRE < VRS Then Inc(VRE,$10);

  VDE := ((_OV And $40) Shr 5) + ((_OV And 2) Shr 1);
  VDE := (VDE Shl 8) + _VDE;

  VBS := ((_MSL And $20) Shr 4) + ((_OV And 8) Shr 3);
  VBS := (VBS Shl 8) + _VBS;

  VBE := (VBS And $FF00) + (_VBE And $FF);  { Not really standard VGA... }
  While VBE < VBS Do Inc(VBE,$80);          { Correct if necessary       }

  LC  := ((_MSL And $40) Shr 5) + ((_OV And $10) Shr 4);
  LC  := (LC Shl 8) + _LC;

  { Recalculate the number of rows we want.  This is because we know that  }
  { we are in basic 320x200x256 mode 13h, and some custom ones (like mine) }
  { may actually have more than 200 scan lines (my custom software sets it }
  { to 400 scan lines for a more solid look).                              }

{  Rows := Rows * ((VDE + 1) Div 200);}
  Multiplier := ((_MSL And $1F) + 1);

  { If the 200-to-400 bit is set on the Max Scan Line register, multiply }
  { the number of rows by 2                                              }

  If (_MSL And $80) <> 0 Then Multiplier := Multiplier * 2;

  Rows := Rows * Multiplier;

  { Only do something if the rows actually changed }

  If Rows <> VDE + 1 Then
  Begin

    { Recalculate the values }

    Inc(VT ,Rows - (VDE + 1));
    Inc(VRS,Rows - (VDE + 1));
    Inc(VRE,Rows - (VDE + 1));
    Inc(VBS,Rows - (VDE + 1));
    Inc(VBE,Rows - (VDE + 1));
    Inc(LC ,Rows - (VDE + 1));
    Inc(VDE,Rows - (VDE + 1)); { Must do last }

    { Bounds-checking }

    If VT  > 1023 Then VT  := 1023;
    If VRS > 1023 Then VRS := 1023;
    If VRE > 1023 Then VRE := 1023;
    If VDE > 1023 Then VDE := 1023;
    If VBS > 1023 Then VBS := 1023;
    If VBE > 1023 Then VBE := 1023;
    If LC  > 1023 Then LC  := 1023;

    { Break the new values into the registers }

    _VT  := VT  And $FF;
    _MSL := (_MSL And $9F) + ((LC Shr 3) And $40) + ((VBS Shr 4) And $20);
    _VRS := VRS And $FF;
    _VRE := (_VRE And $F0) + (VRE And $F);
    _VDE := VDE And $FF;
    _VBS := VBS And $FF;
    _VBE := VBE And $FF;             { The VGA standard says that VBE is  }
    _LC  := LC  And $FF;             { only seven bits, but my ATI 3D Pro }
    _OV  := ((VRS Shr 2) And $80) +  { Turbo doesn't handle this properly }
            ((VDE Shr 3) And $40) +  { unless I fill in all 8 bits.  I    }
            ((VT  Shr 4) And $20) +  { figure that cards that follow the  }
            ((LC  Shr 4) And $10) +  { standard properly shouldn't be     }
            ((VBS Shr 5) And $08) +  { bothered by the extra bit...       }
            ((VRS Shr 6) And $04) +
            ((VDE Shr 7) And $02) +
            ((VT  Shr 8) And $01);

(*
  TextMode(C80);
  WriteLn('OriginalRows = ',OriginalRows);
  WriteLn('Multiplier   = ',Multiplier);
  WriteLn('Rows         = ',Rows);
  WriteLn;
  WriteLn('VT           = ',VT);
  WriteLn('VRS          = ',VRS);
  WriteLn('VRE          = ',VRE);
  WriteLn('VBS          = ',VBS);
  WriteLn('VBE          = ',VBE);
  WriteLn('LC           = ',LC);
  WriteLn('VDE          = ',VDE);
  WriteLn;
  WriteLn('_VT          = ',HexByte(_VT));
  WriteLn('_OV          = ',HexByte(_OV));
  WriteLn('_MSL         = ',HexByte(_MSL));
  WriteLn('_VRS         = ',HexByte(_VRS));
  WriteLn('_VRE         = ',HexByte(_VRE));
  WriteLn('_VDE         = ',HexByte(_VDE));
  WriteLn('_VBS         = ',HexByte(_VBS));
  WriteLn('_VBE         = ',HexByte(_VBE));
  WriteLn('_LC          = ',HexByte(_LC));
  ReadKey;
  Asm
    MOV  AX,0Dh
    INT  10h
  End; { Asm }
  Set160ColsA;
  UnprotectCRTC;
*)

    { For some bizarre reason, my new ATI All-In-Wonder 128 won't display }
    { the screen if the total VRS is 512, so force it to 513 in that case }

    If _VRS = 0 Then _VRS := _VRS Or $01;


    { Change to new rows by changing the vertical registers }

    Asm
      MOV   DX,CRTC_INDEX

      MOV   AL,VERT_TOTAL
      MOV   AH,BYTE PTR _VT
      OUT   DX,AX

      MOV   AL,OVERFLOW
      MOV   AH,BYTE PTR _OV
      OUT   DX,AX

      MOV   AL,MAX_SCAN_LINE
      MOV   AH,BYTE PTR _MSL
      OUT   DX,AX

      MOV   AL,START_VERT_RETRACE
      MOV   AH,BYTE PTR _VRS
      OUT   DX,AX

      MOV   AL,END_VERT_RETRACE
      MOV   AH,BYTE PTR _VRE
      OUT   DX,AX

      MOV   AL,VERT_DISPLAY_END
      MOV   AH,BYTE PTR _VDE
      OUT   DX,AX

      MOV   AL,START_VERT_BLANK
      MOV   AH,BYTE PTR _VBS
      OUT   DX,AX

      MOV   AL,END_VERT_BLANK
      MOV   AH,BYTE PTR _VBE
      OUT   DX,AX

      MOV   AL,LINE_COMPARE
      MOV   AH,BYTE PTR _LC
      OUT   DX,AX
    End; { Asm }

    { If the requested number of scan lines is 480 or larger, see if we }
    { have to change the VGA output crystal.  Do this only if the       }
    { current crystal is the basic 400-scan line crystal, so we don't   }
    { mess up customized VGA modes.                                     }

    If (OriginalRows * Multiplier >= 480) And ((MiscReg And $0C) = 0) Then
    Begin
      Asm
        MOV   DX,MISC_OUTPUT
        MOV   AL,BYTE PTR MiscReg
        OR    AL,4
        OUT   DX,AL
      End; { Asm }
    End;
  End;
  ProtectCRTC;
End; { SetRows }

Begin
  FileMode := 0;
  AVIFile.Init;
  ClrScr;
  For I := 0 To $F Do New(IntvMemPtr[I]);
  New(ScreenColl);
  New(ScreenCollB);
  New(DoubleBuf);

  DoublePtr := DoubleBuf;
{  If Ofs(DoublePtr^) <> 0 Then DoublePtr := Ptr(Seg(DoublePtr^) + 1,0);}

  Top     := 0;
  Sel     := 0;
  UseMenu := False;

  InitConfig(Config,Playback_Freq,Version);

  Playback_Freq := Config.PlaybackRate;

  Repeat
    GameFileName := Menu(Version,Top,Sel,
                    Playback_Freq,DoSound,UseMenu,Config);

    If GameFileName <> '' Then
    Begin

      Asm
        MOV   AX,0013h
        INT   10h
      End; { Asm }

      If Config.ExtraLines Then SetRows(204);

      FormShow;
      InitEmulator;
      If Debugger Then DebugAddr := Regs[7];
      Trace := 0;
      FillChar(SmallSoundBuf,SizeOf(SmallSoundBuf),#0);
      ResetSound := True;
      Repeat

        InitKeyboard;

        If Config.DoSound Then
        Begin
          If Cart = CartECS
           Then InitSound(Playback_Freq,2,ResetSound)
           Else InitSound(Playback_Freq,1,ResetSound);
          If Debugger Then ResetSound := False;
        End;

        T0     := Clock;
        Frames := 0;
        Time0  := Clock;

        LogOutput   := {True;} False;

        Emulating   := True;
        Importing   := False;         { Not importing ECS program         }
        ECSSave     := False;         { Not saving program to cassette    }
        ECSLoad     := False;         { Not loading program from cassette }
        ECSLoadable := False;         { Can load program from cassette    }
        DoSlowDown  := True;          { Slow down PC if necessary         }
        ECSKey      := False;         { No key currently being typed in   }
        ImportKey   := ECSInvalidKey; { No key currently being typed in   }
        ImportShift := False;         { ECS Shift key not needed          }
        ECSDelay    := 0;             { Reset auto-repeat delay           }
        ECSPCKey    := 0;             { No PC keyboard key being pressed  }
        Move(Key,ECSKeyList,SizeOf(ECSKeyList));

        ReadMem  := False;
        WriteMem := False;
        RWMemLoc := 0;
{
        Assign(VoiceLogFile,'VOICE.LOG');
        ReWrite(VoiceLogFile);
}
        Emulate;
        If Importing Then Close(ImportFile);

{        Close(VoiceLogFile);}

        T1 := Clock;

        If Config.DoSound Then StopSound;

        ExitKeyboard;
        If Debugger Then FormPaint;
      Until (Not Debugger) Or
            Not Debug(IntvMemPtr,Regs,StatusWord,HaltLine,
                      Handle_IO_Write,Handle_IO_Read,SpriteX,SpriteY,FormPaint);
      TextMode(C80);
    End;
  Until Not UseMenu;

  TextMode(C80);
  TextColor(LightGray);
  TextBackground(Black);
  ClrScr;
(*
  Write('Flags = ',HexByte(StatusWord),' ');
  If (StatusWord And 8) <> 0 Then Write('S') Else Write('-');
  If (StatusWord And 4) <> 0 Then Write('Z') Else Write('-');
  If (StatusWord And 2) <> 0 Then Write('O') Else Write('-');
  If (StatusWord And 1) <> 0 Then Write('C') Else Write('-');
  WriteLn;
  Write('Interrupts ');
  If Interrupts Then WriteLn('ON') Else WriteLn('OFF');
  WriteLn('DoubleByte = ',DoubleByte);
  Write('Regs = ');
  For I := 0 To 7 Do Write(HexWord(Regs[I]),' ');
  WriteLn;
  WriteLn;
  For I := $2F0 To $2FF Do Write(HexWord(IntvMemW(I)),' ');
  WriteLn;
  Write('STIC X    = ');
  For I := 0 To 7 Do Write(HexWord(IntvMemW(I)),' ');
  WriteLn;
  Write('STIC Y    = ');
  For I := 0 To 7 Do Write(HexWord(IntvMemW(I + 8)),' ');
  WriteLn;
  Write('STIC Attr = ');
  For I := 0 To 7 Do Write(HexWord(IntvMemW(I + 16)),' ');
  WriteLn;
  Write('STIC Coll = ');
  For I := 0 To 7 Do Write(HexWord(IntvMemW(I + 24)),' ');
  WriteLn;
  WriteLn;
  For J := 0 To 7 Do
  Begin
    For I := $0 To 7 Do Write(HexWord(IntvMemW($31D + J * 8 + I)),' ');
    WriteLn;
  End; { For J }
  WriteLn;
  For J := 0 To 11 Do
  Begin
    For I := 0 To 14 Do Write(HexWord(IntvMemW($200 + J * 20 + I)),' ');
    WriteLn;
  End; { For J }

  WriteLn;
  For I := 0 To $F Do Write(HexByte(IntvMemPtr[0]^[$F0 + I]),' ');
  WriteLn;
  WriteLn('ECSLeftController  = ',Form1.ECSLeftController);
  WriteLn('ECSRightController = ',Form1.ECSRightController);
  WriteLn;
  If T1 > T0 Then WriteLn('FPS = ',(Frames / ((T1 - T0) / 1000)):7:3);

  WriteLn(((60 / 59.989) * 2001501):11:5);
  WriteLn;
  WriteLn('IllegalWrite = ',HexWord(IllegalWrite));
  WriteLn('IllegalRead  = ',HexWord(IllegalRead));
  For I := 0 To 7 Do Write(HexWord(IllegalRegs[I]),' ');
  WriteLn;
*)
(*
  Assign(LogFile,'INTVDUMP.LOG');
  ReWrite(LogFile);
  For I := 0 To $F Do
  Begin
    For J := 0 To $FFF Do
    Begin
      Write(LogFile,HexWord(IntvMemPtr[I]^[J]));
      Case (J And $F) Of
     0..6: Write(LogFile,' ');
        7: Write(LogFile,'-');
    8..14: Write(LogFile,' ');
       15: WriteLn(LogFile);
      End; { Case }
    End; { For J }
  End; { For I }
  Close(LogFile);
*)
  Dispose(DoubleBuf);
  Dispose(ScreenColl);
  Dispose(ScreenCollB);
  For I := 0 To $F Do Dispose(IntvMemPtr[I]);
  If BreakExpColl <> Nil Then Dispose(BreakExpColl,Done);
  If AVIFile.Opened Then AVIFile.Close;
End.
